/* SlingshotView.c generated by valac 0.56.7, the Vala compiler
 * generated from SlingshotView.vala, do not modify */

/*
 * Copyright 2019–2021 elementary, Inc. (https://elementary.io)
 *           2011-2012 Giulio Collura
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "slingshot.h"
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <plank.h>
#include <granite.h>
#include <gee.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW = 0,
	SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW = 1,
	SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW
} SlingshotSlingshotViewModality;

#define SLINGSHOT_SLINGSHOT_VIEW_TYPE_MODALITY (slingshot_slingshot_view_modality_get_type ())
enum  {
	SLINGSHOT_SLINGSHOT_VIEW_0_PROPERTY,
	SLINGSHOT_SLINGSHOT_VIEW_NUM_PROPERTIES
};
static GParamSpec* slingshot_slingshot_view_properties[SLINGSHOT_SLINGSHOT_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _SlingshotSlingshotViewSearchData SlingshotSlingshotViewSearchData;
enum  {
	SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL,
	SLINGSHOT_SLINGSHOT_VIEW_NUM_SIGNALS
};
static guint slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_NUM_SIGNALS] = {0};

struct _SlingshotSlingshotViewPrivate {
	SlingshotBackendSynapseSearch* synapse;
	GdkScreen* screen;
	GtkRevealer* view_selector_revealer;
	SlingshotSlingshotViewModality modality;
	SlingshotWidgetsGrid* grid_view;
	SlingshotWidgetsSearchView* search_view;
	SlingshotWidgetsCategoryView* category_view;
};

struct _Block1Data {
	int _ref_count_;
	SlingshotSlingshotView* self;
	gchar* sender_name;
	GVariant* parameters;
};

struct _Block2Data {
	int _ref_count_;
	SlingshotSlingshotView* self;
	GeeList* matches;
	gchar* text;
	gpointer _async_data_;
};

struct _SlingshotSlingshotViewSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SlingshotSlingshotView* self;
	gchar* text;
	SynapseSearchMatch* search_match;
	SynapseMatch* target;
	Block2Data* _data2_;
	gchar* stripped;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	SlingshotBackendSynapseSearch* _tmp2_;
	GeeList* _tmp3_;
	SlingshotBackendSynapseSearch* _tmp4_;
	GeeList* _tmp5_;
};

static gint SlingshotSlingshotView_private_offset;
static gpointer slingshot_slingshot_view_parent_class = NULL;
static GSettings* slingshot_slingshot_view__settings;
static GSettings* slingshot_slingshot_view__settings = NULL;
static PlankUnityClientIface * slingshot_slingshot_view_plank_unity_client_parent_iface = NULL;

static GType slingshot_slingshot_view_modality_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void slingshot_slingshot_view_real_update_launcher_entry (PlankUnityClient* base,
                                                          const gchar* sender_name,
                                                          GVariant* parameters,
                                                          gboolean is_retry);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean ___lambda67_ (Block1Data* _data1_);
static gboolean ____lambda67__gsource_func (gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void slingshot_slingshot_view_real_remove_launcher_entry (PlankUnityClient* base,
                                                          const gchar* sender_name);
static void slingshot_slingshot_view_search_entry_activated (SlingshotSlingshotView* self);
static void slingshot_slingshot_view_set_modality (SlingshotSlingshotView* self,
                                            SlingshotSlingshotViewModality new_modality);
static GSettings* slingshot_slingshot_view_get_settings (void);
static void slingshot_slingshot_view_search_data_free (gpointer _data);
static void slingshot_slingshot_view_search (SlingshotSlingshotView* self,
                                      const gchar* text,
                                      SynapseSearchMatch* search_match,
                                      SynapseMatch* target,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void slingshot_slingshot_view_search_finish (SlingshotSlingshotView* self,
                                             GAsyncResult* _res_);
static gboolean slingshot_slingshot_view_search_co (SlingshotSlingshotViewSearchData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ___lambda68_ (SlingshotSlingshotView* self);
static gboolean ____lambda68__gsource_func (gpointer self);
static void slingshot_slingshot_view_search_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static gboolean __lambda69_ (Block2Data* _data2_);
static gboolean ___lambda69__gsource_func (gpointer self);
static void slingshot_slingshot_view_set_settings (GSettings* value);
static GObject * slingshot_slingshot_view_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _slingshot_slingshot_view___lambda70_ (SlingshotSlingshotView* self,
                                            SynapseSearchMatch* match,
                                            SynapseMatch* target);
static void __slingshot_slingshot_view___lambda70__slingshot_widgets_search_view_start_search (SlingshotWidgetsSearchView* _sender,
                                                                                        SynapseSearchMatch* search_match,
                                                                                        SynapseMatch* target,
                                                                                        gpointer self);
static gboolean _slingshot_slingshot_view___lambda71_ (SlingshotSlingshotView* self);
static gboolean __slingshot_slingshot_view___lambda71__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                           GdkEventFocus* event,
                                                                           gpointer self);
static gboolean _slingshot_slingshot_view_on_event_box_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                      GdkEventKey* event,
                                                                                      gpointer self);
static gboolean _slingshot_slingshot_view_on_search_view_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                        GdkEventKey* event,
                                                                                        gpointer self);
static void _slingshot_slingshot_view___lambda72_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda72__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                             gpointer self);
static void _slingshot_slingshot_view_search_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                          gpointer self);
static void _slingshot_slingshot_view___lambda73_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda73__slingshot_widgets_category_view_search_focus_request (SlingshotWidgetsCategoryView* _sender,
                                                                                                  gpointer self);
static void _slingshot_slingshot_view___lambda74_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda74__slingshot_widgets_grid_app_launched (SlingshotWidgetsGrid* _sender,
                                                                                 gpointer self);
static void _slingshot_slingshot_view___lambda75_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda75__slingshot_widgets_search_view_app_launched (SlingshotWidgetsSearchView* _sender,
                                                                                        gpointer self);
static void _slingshot_slingshot_view___lambda76_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda76__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                                      GtkWidget* widget,
                                                                                      gpointer self);
static void _slingshot_slingshot_view___lambda77_ (SlingshotSlingshotView* self);
static void __slingshot_slingshot_view___lambda77__slingshot_backend_app_system_changed (SlingshotBackendAppSystem* _sender,
                                                                                  gpointer self);
static void slingshot_slingshot_view_finalize (GObject * obj);
static GType slingshot_slingshot_view_get_type_once (void);
static void _vala_slingshot_slingshot_view_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_slingshot_slingshot_view_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
slingshot_slingshot_view_get_instance_private (SlingshotSlingshotView* self)
{
	return G_STRUCT_MEMBER_P (self, SlingshotSlingshotView_private_offset);
}

static GType
slingshot_slingshot_view_modality_get_type_once (void)
{
	static const GEnumValue values[] = {{SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW, "SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW", "normal-view"}, {SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW, "SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW", "category-view"}, {SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW, "SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW", "search-view"}, {0, NULL, NULL}};
	GType slingshot_slingshot_view_modality_type_id;
	slingshot_slingshot_view_modality_type_id = g_enum_register_static ("SlingshotSlingshotViewModality", values);
	return slingshot_slingshot_view_modality_type_id;
}

static GType
slingshot_slingshot_view_modality_get_type (void)
{
	static volatile gsize slingshot_slingshot_view_modality_type_id__once = 0;
	if (g_once_init_enter (&slingshot_slingshot_view_modality_type_id__once)) {
		GType slingshot_slingshot_view_modality_type_id;
		slingshot_slingshot_view_modality_type_id = slingshot_slingshot_view_modality_get_type_once ();
		g_once_init_leave (&slingshot_slingshot_view_modality_type_id__once, slingshot_slingshot_view_modality_type_id);
	}
	return slingshot_slingshot_view_modality_type_id__once;
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 172 "../src/SlingshotView.vala"
	return self ? g_variant_ref (self) : NULL;
#line 239 "SlingshotView.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 172 "../src/SlingshotView.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 172 "../src/SlingshotView.vala"
	return _data1_;
#line 249 "SlingshotView.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 172 "../src/SlingshotView.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 259 "SlingshotView.c"
		SlingshotSlingshotView* self;
#line 172 "../src/SlingshotView.vala"
		self = _data1_->self;
#line 172 "../src/SlingshotView.vala"
		_g_free0 (_data1_->sender_name);
#line 172 "../src/SlingshotView.vala"
		_g_variant_unref0 (_data1_->parameters);
#line 172 "../src/SlingshotView.vala"
		_g_object_unref0 (self);
#line 172 "../src/SlingshotView.vala"
		g_slice_free (Block1Data, _data1_);
#line 271 "SlingshotView.c"
	}
}

static gboolean
___lambda67_ (Block1Data* _data1_)
{
	SlingshotSlingshotView* self;
	gboolean result;
#line 176 "../src/SlingshotView.vala"
	self = _data1_->self;
#line 177 "../src/SlingshotView.vala"
	plank_unity_client_update_launcher_entry ((PlankUnityClient*) self, _data1_->sender_name, _data1_->parameters, TRUE);
#line 178 "../src/SlingshotView.vala"
	result = FALSE;
#line 178 "../src/SlingshotView.vala"
	return result;
#line 288 "SlingshotView.c"
}

static gboolean
____lambda67__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda67_ (self);
#line 176 "../src/SlingshotView.vala"
	return result;
#line 298 "SlingshotView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 188 "../src/SlingshotView.vala"
	return self ? g_object_ref (self) : NULL;
#line 306 "SlingshotView.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 188 "../src/SlingshotView.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 314 "SlingshotView.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 188 "../src/SlingshotView.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 322 "SlingshotView.c"
}

static void
slingshot_slingshot_view_real_update_launcher_entry (PlankUnityClient* base,
                                                     const gchar* sender_name,
                                                     GVariant* parameters,
                                                     gboolean is_retry)
{
	SlingshotSlingshotView * self;
	Block1Data* _data1_;
	gchar* _tmp0_;
	GVariant* _tmp1_;
	gchar* app_uri = NULL;
	GVariantIter* prop_iter = NULL;
	gchar* _tmp2_ = NULL;
	GVariantIter* _tmp3_ = NULL;
	SlingshotBackendAppSystem* _tmp4_;
	GSList* _tmp5_;
#line 172 "../src/SlingshotView.vala"
	self = (SlingshotSlingshotView*) base;
#line 172 "../src/SlingshotView.vala"
	g_return_if_fail (sender_name != NULL);
#line 172 "../src/SlingshotView.vala"
	g_return_if_fail (parameters != NULL);
#line 172 "../src/SlingshotView.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 172 "../src/SlingshotView.vala"
	_data1_->_ref_count_ = 1;
#line 172 "../src/SlingshotView.vala"
	_data1_->self = g_object_ref (self);
#line 172 "../src/SlingshotView.vala"
	_tmp0_ = g_strdup (sender_name);
#line 172 "../src/SlingshotView.vala"
	_g_free0 (_data1_->sender_name);
#line 172 "../src/SlingshotView.vala"
	_data1_->sender_name = _tmp0_;
#line 172 "../src/SlingshotView.vala"
	_tmp1_ = _g_variant_ref0 (parameters);
#line 172 "../src/SlingshotView.vala"
	_g_variant_unref0 (_data1_->parameters);
#line 172 "../src/SlingshotView.vala"
	_data1_->parameters = _tmp1_;
#line 173 "../src/SlingshotView.vala"
	if (!is_retry) {
#line 176 "../src/SlingshotView.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda67__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 181 "../src/SlingshotView.vala"
		block1_data_unref (_data1_);
#line 181 "../src/SlingshotView.vala"
		_data1_ = NULL;
#line 181 "../src/SlingshotView.vala"
		return;
#line 375 "SlingshotView.c"
	}
#line 186 "../src/SlingshotView.vala"
	g_variant_get (_data1_->parameters, "(sa{sv})", &_tmp2_, &_tmp3_, NULL);
#line 186 "../src/SlingshotView.vala"
	_g_free0 (app_uri);
#line 186 "../src/SlingshotView.vala"
	app_uri = _tmp2_;
#line 186 "../src/SlingshotView.vala"
	_g_variant_iter_free0 (prop_iter);
#line 186 "../src/SlingshotView.vala"
	prop_iter = _tmp3_;
#line 188 "../src/SlingshotView.vala"
	_tmp4_ = self->app_system;
#line 188 "../src/SlingshotView.vala"
	_tmp5_ = slingshot_backend_app_system_get_apps_by_name (_tmp4_);
#line 391 "SlingshotView.c"
	{
		GSList* app_collection = NULL;
		GSList* app_it = NULL;
#line 188 "../src/SlingshotView.vala"
		app_collection = _tmp5_;
#line 188 "../src/SlingshotView.vala"
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
#line 399 "SlingshotView.c"
			SlingshotBackendApp* _tmp6_;
			SlingshotBackendApp* app = NULL;
#line 188 "../src/SlingshotView.vala"
			_tmp6_ = _g_object_ref0 ((SlingshotBackendApp*) app_it->data);
#line 188 "../src/SlingshotView.vala"
			app = _tmp6_;
#line 406 "SlingshotView.c"
			{
				const gchar* _tmp7_;
				SlingshotBackendApp* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gboolean _tmp13_;
#line 189 "../src/SlingshotView.vala"
				_tmp7_ = app_uri;
#line 189 "../src/SlingshotView.vala"
				_tmp8_ = app;
#line 189 "../src/SlingshotView.vala"
				_tmp9_ = slingshot_backend_app_get_desktop_id (_tmp8_);
#line 189 "../src/SlingshotView.vala"
				_tmp10_ = _tmp9_;
#line 189 "../src/SlingshotView.vala"
				_tmp11_ = g_strconcat ("application://", _tmp10_, NULL);
#line 189 "../src/SlingshotView.vala"
				_tmp12_ = _tmp11_;
#line 189 "../src/SlingshotView.vala"
				_tmp13_ = g_strcmp0 (_tmp7_, _tmp12_) == 0;
#line 189 "../src/SlingshotView.vala"
				_g_free0 (_tmp12_);
#line 189 "../src/SlingshotView.vala"
				if (_tmp13_) {
#line 433 "SlingshotView.c"
					SlingshotBackendApp* _tmp14_;
					GVariantIter* _tmp15_;
#line 190 "../src/SlingshotView.vala"
					_tmp14_ = app;
#line 190 "../src/SlingshotView.vala"
					_tmp15_ = prop_iter;
#line 190 "../src/SlingshotView.vala"
					slingshot_backend_app_perform_unity_update (_tmp14_, _data1_->sender_name, _tmp15_);
#line 442 "SlingshotView.c"
				}
#line 188 "../src/SlingshotView.vala"
				_g_object_unref0 (app);
#line 446 "SlingshotView.c"
			}
		}
#line 188 "../src/SlingshotView.vala"
		(app_collection == NULL) ? NULL : (app_collection = (_g_slist_free__g_object_unref0_ (app_collection), NULL));
#line 451 "SlingshotView.c"
	}
#line 172 "../src/SlingshotView.vala"
	_g_variant_iter_free0 (prop_iter);
#line 172 "../src/SlingshotView.vala"
	_g_free0 (app_uri);
#line 172 "../src/SlingshotView.vala"
	block1_data_unref (_data1_);
#line 172 "../src/SlingshotView.vala"
	_data1_ = NULL;
#line 461 "SlingshotView.c"
}

static void
slingshot_slingshot_view_real_remove_launcher_entry (PlankUnityClient* base,
                                                     const gchar* sender_name)
{
	SlingshotSlingshotView * self;
	SlingshotBackendAppSystem* _tmp0_;
	GSList* _tmp1_;
#line 195 "../src/SlingshotView.vala"
	self = (SlingshotSlingshotView*) base;
#line 195 "../src/SlingshotView.vala"
	g_return_if_fail (sender_name != NULL);
#line 196 "../src/SlingshotView.vala"
	_tmp0_ = self->app_system;
#line 196 "../src/SlingshotView.vala"
	_tmp1_ = slingshot_backend_app_system_get_apps_by_name (_tmp0_);
#line 479 "SlingshotView.c"
	{
		GSList* app_collection = NULL;
		GSList* app_it = NULL;
#line 196 "../src/SlingshotView.vala"
		app_collection = _tmp1_;
#line 196 "../src/SlingshotView.vala"
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
#line 487 "SlingshotView.c"
			SlingshotBackendApp* _tmp2_;
			SlingshotBackendApp* app = NULL;
#line 196 "../src/SlingshotView.vala"
			_tmp2_ = _g_object_ref0 ((SlingshotBackendApp*) app_it->data);
#line 196 "../src/SlingshotView.vala"
			app = _tmp2_;
#line 494 "SlingshotView.c"
			{
				SlingshotBackendApp* _tmp3_;
#line 197 "../src/SlingshotView.vala"
				_tmp3_ = app;
#line 197 "../src/SlingshotView.vala"
				slingshot_backend_app_remove_launcher_entry (_tmp3_, sender_name);
#line 196 "../src/SlingshotView.vala"
				_g_object_unref0 (app);
#line 503 "SlingshotView.c"
			}
		}
#line 196 "../src/SlingshotView.vala"
		(app_collection == NULL) ? NULL : (app_collection = (_g_slist_free__g_object_unref0_ (app_collection), NULL));
#line 508 "SlingshotView.c"
	}
}

static void
slingshot_slingshot_view_search_entry_activated (SlingshotSlingshotView* self)
{
#line 202 "../src/SlingshotView.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/SlingshotView.vala"
	if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW) {
#line 519 "SlingshotView.c"
		SlingshotWidgetsSearchView* _tmp0_;
#line 204 "../src/SlingshotView.vala"
		_tmp0_ = self->priv->search_view;
#line 204 "../src/SlingshotView.vala"
		slingshot_widgets_search_view_activate_selection (_tmp0_);
#line 525 "SlingshotView.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 548 "SlingshotView.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 552 "SlingshotView.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 558 "SlingshotView.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 562 "SlingshotView.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 566 "SlingshotView.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 574 "SlingshotView.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 602 "SlingshotView.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 611 "SlingshotView.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 625 "SlingshotView.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 634 "SlingshotView.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 648 "SlingshotView.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 657 "SlingshotView.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 666 "SlingshotView.c"
}

gboolean
slingshot_slingshot_view_on_search_view_key_press (SlingshotSlingshotView* self,
                                                   GdkEventKey* event)
{
	gchar* key = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 214 "../src/SlingshotView.vala"
	static GQuark _tmp4_label0 = 0;
#line 214 "../src/SlingshotView.vala"
	static GQuark _tmp4_label1 = 0;
#line 683 "SlingshotView.c"
	gboolean result;
#line 211 "../src/SlingshotView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../src/SlingshotView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 212 "../src/SlingshotView.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 212 "../src/SlingshotView.vala"
	_tmp1_ = string_replace (_tmp0_, "KP_", "");
#line 212 "../src/SlingshotView.vala"
	key = _tmp1_;
#line 214 "../src/SlingshotView.vala"
	_tmp2_ = key;
#line 214 "../src/SlingshotView.vala"
	_tmp3_ = _tmp2_;
#line 214 "../src/SlingshotView.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 214 "../src/SlingshotView.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("Down")))) {
#line 214 "../src/SlingshotView.vala"
		switch (0) {
#line 705 "SlingshotView.c"
			default:
			{
				GtkSearchEntry* _tmp6_;
#line 216 "../src/SlingshotView.vala"
				_tmp6_ = self->search_entry;
#line 216 "../src/SlingshotView.vala"
				g_signal_emit_by_name ((GtkWidget*) _tmp6_, "move-focus", GTK_DIR_TAB_FORWARD);
#line 217 "../src/SlingshotView.vala"
				result = GDK_EVENT_STOP;
#line 217 "../src/SlingshotView.vala"
				_g_free0 (key);
#line 217 "../src/SlingshotView.vala"
				return result;
#line 719 "SlingshotView.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("Escape")))) {
#line 214 "../src/SlingshotView.vala"
		switch (0) {
#line 725 "SlingshotView.c"
			default:
			{
				GtkSearchEntry* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 220 "../src/SlingshotView.vala"
				_tmp7_ = self->search_entry;
#line 220 "../src/SlingshotView.vala"
				_tmp8_ = gtk_entry_get_text ((GtkEntry*) _tmp7_);
#line 220 "../src/SlingshotView.vala"
				_tmp9_ = _tmp8_;
#line 220 "../src/SlingshotView.vala"
				_tmp10_ = strlen (_tmp9_);
#line 220 "../src/SlingshotView.vala"
				_tmp11_ = _tmp10_;
#line 220 "../src/SlingshotView.vala"
				if (_tmp11_ > 0) {
#line 745 "SlingshotView.c"
					GtkSearchEntry* _tmp12_;
#line 221 "../src/SlingshotView.vala"
					_tmp12_ = self->search_entry;
#line 221 "../src/SlingshotView.vala"
					gtk_entry_set_text ((GtkEntry*) _tmp12_, "");
#line 751 "SlingshotView.c"
				} else {
#line 223 "../src/SlingshotView.vala"
					g_signal_emit (self, slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL], 0);
#line 755 "SlingshotView.c"
				}
#line 226 "../src/SlingshotView.vala"
				result = GDK_EVENT_STOP;
#line 226 "../src/SlingshotView.vala"
				_g_free0 (key);
#line 226 "../src/SlingshotView.vala"
				return result;
#line 763 "SlingshotView.c"
			}
		}
	}
#line 229 "../src/SlingshotView.vala"
	result = GDK_EVENT_PROPAGATE;
#line 229 "../src/SlingshotView.vala"
	_g_free0 (key);
#line 229 "../src/SlingshotView.vala"
	return result;
#line 773 "SlingshotView.c"
}

gboolean
slingshot_slingshot_view_on_event_box_key_press (SlingshotSlingshotView* self,
                                                 GdkEventKey* event)
{
	gchar* key = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GQuark _tmp20_ = 0U;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label0 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label1 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label2 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label3 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label4 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label5 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label6 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label7 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label8 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label9 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label10 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label11 = 0;
#line 277 "../src/SlingshotView.vala"
	static GQuark _tmp19_label12 = 0;
#line 812 "SlingshotView.c"
	gboolean result;
#line 232 "../src/SlingshotView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 232 "../src/SlingshotView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 233 "../src/SlingshotView.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 233 "../src/SlingshotView.vala"
	_tmp1_ = string_replace (_tmp0_, "KP_", "");
#line 233 "../src/SlingshotView.vala"
	key = _tmp1_;
#line 234 "../src/SlingshotView.vala"
	if ((event->state & GDK_CONTROL_MASK) != 0) {
#line 826 "SlingshotView.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		GQuark _tmp5_ = 0U;
#line 235 "../src/SlingshotView.vala"
		static GQuark _tmp4_label0 = 0;
#line 235 "../src/SlingshotView.vala"
		static GQuark _tmp4_label1 = 0;
#line 235 "../src/SlingshotView.vala"
		_tmp2_ = key;
#line 235 "../src/SlingshotView.vala"
		_tmp3_ = _tmp2_;
#line 235 "../src/SlingshotView.vala"
		_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 235 "../src/SlingshotView.vala"
		if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("1")))) {
#line 235 "../src/SlingshotView.vala"
			switch (0) {
#line 844 "SlingshotView.c"
				default:
				{
					GraniteWidgetsModeButton* _tmp6_;
#line 237 "../src/SlingshotView.vala"
					_tmp6_ = self->view_selector;
#line 237 "../src/SlingshotView.vala"
					granite_widgets_mode_button_set_selected (_tmp6_, 0);
#line 238 "../src/SlingshotView.vala"
					result = GDK_EVENT_STOP;
#line 238 "../src/SlingshotView.vala"
					_g_free0 (key);
#line 238 "../src/SlingshotView.vala"
					return result;
#line 858 "SlingshotView.c"
				}
			}
		} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("2")))) {
#line 235 "../src/SlingshotView.vala"
			switch (0) {
#line 864 "SlingshotView.c"
				default:
				{
					GraniteWidgetsModeButton* _tmp7_;
#line 240 "../src/SlingshotView.vala"
					_tmp7_ = self->view_selector;
#line 240 "../src/SlingshotView.vala"
					granite_widgets_mode_button_set_selected (_tmp7_, 1);
#line 241 "../src/SlingshotView.vala"
					result = GDK_EVENT_STOP;
#line 241 "../src/SlingshotView.vala"
					_g_free0 (key);
#line 241 "../src/SlingshotView.vala"
					return result;
#line 878 "SlingshotView.c"
				}
			}
		}
	}
#line 246 "../src/SlingshotView.vala"
	if ((event->state & GDK_MOD1_MASK) != 0) {
#line 885 "SlingshotView.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GQuark _tmp11_ = 0U;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label0 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label1 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label2 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label3 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label4 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label5 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label6 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label7 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label8 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label9 = 0;
#line 247 "../src/SlingshotView.vala"
		static GQuark _tmp10_label10 = 0;
#line 247 "../src/SlingshotView.vala"
		_tmp8_ = key;
#line 247 "../src/SlingshotView.vala"
		_tmp9_ = _tmp8_;
#line 247 "../src/SlingshotView.vala"
		_tmp11_ = (NULL == _tmp9_) ? 0 : g_quark_from_string (_tmp9_);
#line 247 "../src/SlingshotView.vala"
		if (_tmp11_ == ((0 != _tmp10_label0) ? _tmp10_label0 : (_tmp10_label0 = g_quark_from_static_string ("F4")))) {
#line 247 "../src/SlingshotView.vala"
			switch (0) {
#line 921 "SlingshotView.c"
				default:
				{
#line 249 "../src/SlingshotView.vala"
					g_signal_emit (self, slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL], 0);
#line 250 "../src/SlingshotView.vala"
					result = GDK_EVENT_STOP;
#line 250 "../src/SlingshotView.vala"
					_g_free0 (key);
#line 250 "../src/SlingshotView.vala"
					return result;
#line 932 "SlingshotView.c"
				}
			}
		} else if ((((((((((_tmp11_ == ((0 != _tmp10_label1) ? _tmp10_label1 : (_tmp10_label1 = g_quark_from_static_string ("0")))) || (_tmp11_ == ((0 != _tmp10_label2) ? _tmp10_label2 : (_tmp10_label2 = g_quark_from_static_string ("1"))))) || (_tmp11_ == ((0 != _tmp10_label3) ? _tmp10_label3 : (_tmp10_label3 = g_quark_from_static_string ("2"))))) || (_tmp11_ == ((0 != _tmp10_label4) ? _tmp10_label4 : (_tmp10_label4 = g_quark_from_static_string ("3"))))) || (_tmp11_ == ((0 != _tmp10_label5) ? _tmp10_label5 : (_tmp10_label5 = g_quark_from_static_string ("4"))))) || (_tmp11_ == ((0 != _tmp10_label6) ? _tmp10_label6 : (_tmp10_label6 = g_quark_from_static_string ("5"))))) || (_tmp11_ == ((0 != _tmp10_label7) ? _tmp10_label7 : (_tmp10_label7 = g_quark_from_static_string ("6"))))) || (_tmp11_ == ((0 != _tmp10_label8) ? _tmp10_label8 : (_tmp10_label8 = g_quark_from_static_string ("7"))))) || (_tmp11_ == ((0 != _tmp10_label9) ? _tmp10_label9 : (_tmp10_label9 = g_quark_from_static_string ("8"))))) || (_tmp11_ == ((0 != _tmp10_label10) ? _tmp10_label10 : (_tmp10_label10 = g_quark_from_static_string ("9"))))) {
#line 247 "../src/SlingshotView.vala"
			switch (0) {
#line 938 "SlingshotView.c"
				default:
				{
					GtkSearchEntry* _tmp16_;
#line 262 "../src/SlingshotView.vala"
					if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW) {
#line 944 "SlingshotView.c"
						gint page = 0;
						const gchar* _tmp12_;
						gboolean _tmp13_ = FALSE;
#line 263 "../src/SlingshotView.vala"
						_tmp12_ = key;
#line 263 "../src/SlingshotView.vala"
						page = atoi (_tmp12_);
#line 264 "../src/SlingshotView.vala"
						if (page < 0) {
#line 264 "../src/SlingshotView.vala"
							_tmp13_ = TRUE;
#line 956 "SlingshotView.c"
						} else {
#line 264 "../src/SlingshotView.vala"
							_tmp13_ = page == 9;
#line 960 "SlingshotView.c"
						}
#line 264 "../src/SlingshotView.vala"
						if (_tmp13_) {
#line 964 "SlingshotView.c"
							SlingshotWidgetsGrid* _tmp14_;
#line 265 "../src/SlingshotView.vala"
							_tmp14_ = self->priv->grid_view;
#line 265 "../src/SlingshotView.vala"
							slingshot_widgets_grid_go_to_last (_tmp14_);
#line 970 "SlingshotView.c"
						} else {
							SlingshotWidgetsGrid* _tmp15_;
#line 267 "../src/SlingshotView.vala"
							_tmp15_ = self->priv->grid_view;
#line 267 "../src/SlingshotView.vala"
							slingshot_widgets_grid_go_to_number (_tmp15_, page);
#line 977 "SlingshotView.c"
						}
					}
#line 272 "../src/SlingshotView.vala"
					_tmp16_ = self->search_entry;
#line 272 "../src/SlingshotView.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp16_);
#line 273 "../src/SlingshotView.vala"
					result = GDK_EVENT_STOP;
#line 273 "../src/SlingshotView.vala"
					_g_free0 (key);
#line 273 "../src/SlingshotView.vala"
					return result;
#line 990 "SlingshotView.c"
				}
			}
		}
	}
#line 277 "../src/SlingshotView.vala"
	_tmp17_ = key;
#line 277 "../src/SlingshotView.vala"
	_tmp18_ = _tmp17_;
#line 277 "../src/SlingshotView.vala"
	_tmp20_ = (NULL == _tmp18_) ? 0 : g_quark_from_string (_tmp18_);
#line 277 "../src/SlingshotView.vala"
	if (((((((((_tmp20_ == ((0 != _tmp19_label0) ? _tmp19_label0 : (_tmp19_label0 = g_quark_from_static_string ("Down")))) || (_tmp20_ == ((0 != _tmp19_label1) ? _tmp19_label1 : (_tmp19_label1 = g_quark_from_static_string ("Enter"))))) || (_tmp20_ == ((0 != _tmp19_label2) ? _tmp19_label2 : (_tmp19_label2 = g_quark_from_static_string ("Home"))))) || (_tmp20_ == ((0 != _tmp19_label3) ? _tmp19_label3 : (_tmp19_label3 = g_quark_from_static_string ("KP_Enter"))))) || (_tmp20_ == ((0 != _tmp19_label4) ? _tmp19_label4 : (_tmp19_label4 = g_quark_from_static_string ("Left"))))) || (_tmp20_ == ((0 != _tmp19_label5) ? _tmp19_label5 : (_tmp19_label5 = g_quark_from_static_string ("Return"))))) || (_tmp20_ == ((0 != _tmp19_label6) ? _tmp19_label6 : (_tmp19_label6 = g_quark_from_static_string ("Right"))))) || (_tmp20_ == ((0 != _tmp19_label7) ? _tmp19_label7 : (_tmp19_label7 = g_quark_from_static_string ("Tab"))))) || (_tmp20_ == ((0 != _tmp19_label8) ? _tmp19_label8 : (_tmp19_label8 = g_quark_from_static_string ("Up"))))) {
#line 277 "../src/SlingshotView.vala"
		switch (0) {
#line 1005 "SlingshotView.c"
			default:
			{
#line 287 "../src/SlingshotView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 287 "../src/SlingshotView.vala"
				_g_free0 (key);
#line 287 "../src/SlingshotView.vala"
				return result;
#line 1014 "SlingshotView.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label9) ? _tmp19_label9 : (_tmp19_label9 = g_quark_from_static_string ("Page_Up")))) {
#line 277 "../src/SlingshotView.vala"
		switch (0) {
#line 1020 "SlingshotView.c"
			default:
			{
#line 290 "../src/SlingshotView.vala"
				if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW) {
#line 1025 "SlingshotView.c"
					SlingshotWidgetsGrid* _tmp21_;
#line 291 "../src/SlingshotView.vala"
					_tmp21_ = self->priv->grid_view;
#line 291 "../src/SlingshotView.vala"
					slingshot_widgets_grid_go_to_previous (_tmp21_);
#line 1031 "SlingshotView.c"
				} else {
#line 292 "../src/SlingshotView.vala"
					if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW) {
#line 1035 "SlingshotView.c"
						SlingshotWidgetsCategoryView* _tmp22_;
#line 293 "../src/SlingshotView.vala"
						_tmp22_ = self->priv->category_view;
#line 293 "../src/SlingshotView.vala"
						slingshot_widgets_category_view_page_up (_tmp22_);
#line 1041 "SlingshotView.c"
					}
				}
#line 295 "../src/SlingshotView.vala"
				break;
#line 1046 "SlingshotView.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label10) ? _tmp19_label10 : (_tmp19_label10 = g_quark_from_static_string ("Page_Down")))) {
#line 277 "../src/SlingshotView.vala"
		switch (0) {
#line 1052 "SlingshotView.c"
			default:
			{
#line 298 "../src/SlingshotView.vala"
				if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW) {
#line 1057 "SlingshotView.c"
					SlingshotWidgetsGrid* _tmp23_;
#line 299 "../src/SlingshotView.vala"
					_tmp23_ = self->priv->grid_view;
#line 299 "../src/SlingshotView.vala"
					slingshot_widgets_grid_go_to_next (_tmp23_);
#line 1063 "SlingshotView.c"
				} else {
#line 300 "../src/SlingshotView.vala"
					if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW) {
#line 1067 "SlingshotView.c"
						SlingshotWidgetsCategoryView* _tmp24_;
#line 301 "../src/SlingshotView.vala"
						_tmp24_ = self->priv->category_view;
#line 301 "../src/SlingshotView.vala"
						slingshot_widgets_category_view_page_down (_tmp24_);
#line 1073 "SlingshotView.c"
					}
				}
#line 303 "../src/SlingshotView.vala"
				break;
#line 1078 "SlingshotView.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label11) ? _tmp19_label11 : (_tmp19_label11 = g_quark_from_static_string ("BackSpace")))) {
#line 277 "../src/SlingshotView.vala"
		switch (0) {
#line 1084 "SlingshotView.c"
			default:
			{
				GtkSearchEntry* _tmp25_;
				gboolean _tmp26_;
				gboolean _tmp27_;
#line 306 "../src/SlingshotView.vala"
				_tmp25_ = self->search_entry;
#line 306 "../src/SlingshotView.vala"
				g_object_get ((GtkWidget*) _tmp25_, "has-focus", &_tmp26_, NULL);
#line 306 "../src/SlingshotView.vala"
				_tmp27_ = _tmp26_;
#line 306 "../src/SlingshotView.vala"
				if (!_tmp27_) {
#line 1098 "SlingshotView.c"
					GtkSearchEntry* _tmp28_;
					GtkSearchEntry* _tmp29_;
#line 307 "../src/SlingshotView.vala"
					_tmp28_ = self->search_entry;
#line 307 "../src/SlingshotView.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp28_);
#line 308 "../src/SlingshotView.vala"
					_tmp29_ = self->search_entry;
#line 308 "../src/SlingshotView.vala"
					g_signal_emit_by_name ((GtkEntry*) _tmp29_, "move-cursor", GTK_MOVEMENT_BUFFER_ENDS, 0, FALSE);
#line 1109 "SlingshotView.c"
				}
#line 310 "../src/SlingshotView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 310 "../src/SlingshotView.vala"
				_g_free0 (key);
#line 310 "../src/SlingshotView.vala"
				return result;
#line 1117 "SlingshotView.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label12) ? _tmp19_label12 : (_tmp19_label12 = g_quark_from_static_string ("End")))) {
#line 277 "../src/SlingshotView.vala"
		switch (0) {
#line 1123 "SlingshotView.c"
			default:
			{
#line 312 "../src/SlingshotView.vala"
				if (self->priv->modality == SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW) {
#line 1128 "SlingshotView.c"
					SlingshotWidgetsGrid* _tmp30_;
#line 313 "../src/SlingshotView.vala"
					_tmp30_ = self->priv->grid_view;
#line 313 "../src/SlingshotView.vala"
					slingshot_widgets_grid_go_to_last (_tmp30_);
#line 1134 "SlingshotView.c"
				}
#line 316 "../src/SlingshotView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 316 "../src/SlingshotView.vala"
				_g_free0 (key);
#line 316 "../src/SlingshotView.vala"
				return result;
#line 1142 "SlingshotView.c"
			}
		}
	} else {
#line 277 "../src/SlingshotView.vala"
		switch (0) {
#line 1148 "SlingshotView.c"
			default:
			{
				gboolean _tmp31_ = FALSE;
				GtkSearchEntry* _tmp32_;
				gboolean _tmp33_;
				gboolean _tmp34_;
#line 318 "../src/SlingshotView.vala"
				_tmp32_ = self->search_entry;
#line 318 "../src/SlingshotView.vala"
				g_object_get ((GtkWidget*) _tmp32_, "has-focus", &_tmp33_, NULL);
#line 318 "../src/SlingshotView.vala"
				_tmp34_ = _tmp33_;
#line 318 "../src/SlingshotView.vala"
				if (!_tmp34_) {
#line 318 "../src/SlingshotView.vala"
					_tmp31_ = event->is_modifier != ((guint) 1);
#line 1165 "SlingshotView.c"
				} else {
#line 318 "../src/SlingshotView.vala"
					_tmp31_ = FALSE;
#line 1169 "SlingshotView.c"
				}
#line 318 "../src/SlingshotView.vala"
				if (_tmp31_) {
#line 1173 "SlingshotView.c"
					GtkSearchEntry* _tmp35_;
					GtkSearchEntry* _tmp36_;
					GtkSearchEntry* _tmp37_;
					gboolean _tmp38_ = FALSE;
#line 319 "../src/SlingshotView.vala"
					_tmp35_ = self->search_entry;
#line 319 "../src/SlingshotView.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp35_);
#line 320 "../src/SlingshotView.vala"
					_tmp36_ = self->search_entry;
#line 320 "../src/SlingshotView.vala"
					g_signal_emit_by_name ((GtkEntry*) _tmp36_, "move-cursor", GTK_MOVEMENT_BUFFER_ENDS, 0, FALSE);
#line 321 "../src/SlingshotView.vala"
					_tmp37_ = self->search_entry;
#line 321 "../src/SlingshotView.vala"
					g_signal_emit_by_name ((GtkWidget*) _tmp37_, "key-press-event", event, &_tmp38_);
#line 1190 "SlingshotView.c"
				}
#line 323 "../src/SlingshotView.vala"
				result = GDK_EVENT_PROPAGATE;
#line 323 "../src/SlingshotView.vala"
				_g_free0 (key);
#line 323 "../src/SlingshotView.vala"
				return result;
#line 1198 "SlingshotView.c"
			}
		}
	}
#line 327 "../src/SlingshotView.vala"
	result = GDK_EVENT_STOP;
#line 327 "../src/SlingshotView.vala"
	_g_free0 (key);
#line 327 "../src/SlingshotView.vala"
	return result;
#line 1208 "SlingshotView.c"
}

void
slingshot_slingshot_view_show_slingshot (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
	GtkSearchEntry* _tmp1_;
	GtkRevealer* _tmp2_;
	GtkStack* _tmp3_;
	GraniteWidgetsModeButton* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GtkRevealer* _tmp7_;
	GtkStack* _tmp8_;
#line 330 "../src/SlingshotView.vala"
	g_return_if_fail (self != NULL);
#line 331 "../src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 331 "../src/SlingshotView.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp0_, "");
#line 337 "../src/SlingshotView.vala"
	_tmp1_ = self->search_entry;
#line 337 "../src/SlingshotView.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp1_);
#line 339 "../src/SlingshotView.vala"
	_tmp2_ = self->priv->view_selector_revealer;
#line 339 "../src/SlingshotView.vala"
	gtk_revealer_set_transition_type (_tmp2_, GTK_REVEALER_TRANSITION_TYPE_NONE);
#line 340 "../src/SlingshotView.vala"
	_tmp3_ = self->stack;
#line 340 "../src/SlingshotView.vala"
	gtk_stack_set_transition_type (_tmp3_, GTK_STACK_TRANSITION_TYPE_NONE);
#line 341 "../src/SlingshotView.vala"
	_tmp4_ = self->view_selector;
#line 341 "../src/SlingshotView.vala"
	_tmp5_ = granite_widgets_mode_button_get_selected (_tmp4_);
#line 341 "../src/SlingshotView.vala"
	_tmp6_ = _tmp5_;
#line 341 "../src/SlingshotView.vala"
	slingshot_slingshot_view_set_modality (self, (SlingshotSlingshotViewModality) _tmp6_);
#line 342 "../src/SlingshotView.vala"
	_tmp7_ = self->priv->view_selector_revealer;
#line 342 "../src/SlingshotView.vala"
	gtk_revealer_set_transition_type (_tmp7_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
#line 343 "../src/SlingshotView.vala"
	_tmp8_ = self->stack;
#line 343 "../src/SlingshotView.vala"
	gtk_stack_set_transition_type (_tmp8_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 1257 "SlingshotView.c"
}

static void
slingshot_slingshot_view_set_modality (SlingshotSlingshotView* self,
                                       SlingshotSlingshotViewModality new_modality)
{
#line 346 "../src/SlingshotView.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/SlingshotView.vala"
	self->priv->modality = new_modality;
#line 349 "../src/SlingshotView.vala"
	switch (self->priv->modality) {
#line 349 "../src/SlingshotView.vala"
		case SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW:
#line 1272 "SlingshotView.c"
		{
			GSettings* _tmp0_;
			GSettings* _tmp1_;
			GtkRevealer* _tmp4_;
			GtkStack* _tmp5_;
			GtkSearchEntry* _tmp6_;
#line 351 "../src/SlingshotView.vala"
			_tmp0_ = slingshot_slingshot_view_get_settings ();
#line 351 "../src/SlingshotView.vala"
			_tmp1_ = _tmp0_;
#line 351 "../src/SlingshotView.vala"
			if (g_settings_get_boolean (_tmp1_, "use-category")) {
#line 1285 "SlingshotView.c"
				GSettings* _tmp2_;
				GSettings* _tmp3_;
#line 352 "../src/SlingshotView.vala"
				_tmp2_ = slingshot_slingshot_view_get_settings ();
#line 352 "../src/SlingshotView.vala"
				_tmp3_ = _tmp2_;
#line 352 "../src/SlingshotView.vala"
				g_settings_set_boolean (_tmp3_, "use-category", FALSE);
#line 1294 "SlingshotView.c"
			}
#line 355 "../src/SlingshotView.vala"
			_tmp4_ = self->priv->view_selector_revealer;
#line 355 "../src/SlingshotView.vala"
			gtk_revealer_set_reveal_child (_tmp4_, TRUE);
#line 356 "../src/SlingshotView.vala"
			_tmp5_ = self->stack;
#line 356 "../src/SlingshotView.vala"
			gtk_stack_set_visible_child_name (_tmp5_, "normal");
#line 358 "../src/SlingshotView.vala"
			_tmp6_ = self->search_entry;
#line 358 "../src/SlingshotView.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 359 "../src/SlingshotView.vala"
			break;
#line 1310 "SlingshotView.c"
		}
#line 349 "../src/SlingshotView.vala"
		case SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW:
#line 1314 "SlingshotView.c"
		{
			GSettings* _tmp7_;
			GSettings* _tmp8_;
			GtkRevealer* _tmp11_;
			GtkStack* _tmp12_;
			GtkSearchEntry* _tmp13_;
#line 362 "../src/SlingshotView.vala"
			_tmp7_ = slingshot_slingshot_view_get_settings ();
#line 362 "../src/SlingshotView.vala"
			_tmp8_ = _tmp7_;
#line 362 "../src/SlingshotView.vala"
			if (!g_settings_get_boolean (_tmp8_, "use-category")) {
#line 1327 "SlingshotView.c"
				GSettings* _tmp9_;
				GSettings* _tmp10_;
#line 363 "../src/SlingshotView.vala"
				_tmp9_ = slingshot_slingshot_view_get_settings ();
#line 363 "../src/SlingshotView.vala"
				_tmp10_ = _tmp9_;
#line 363 "../src/SlingshotView.vala"
				g_settings_set_boolean (_tmp10_, "use-category", TRUE);
#line 1336 "SlingshotView.c"
			}
#line 366 "../src/SlingshotView.vala"
			_tmp11_ = self->priv->view_selector_revealer;
#line 366 "../src/SlingshotView.vala"
			gtk_revealer_set_reveal_child (_tmp11_, TRUE);
#line 367 "../src/SlingshotView.vala"
			_tmp12_ = self->stack;
#line 367 "../src/SlingshotView.vala"
			gtk_stack_set_visible_child_name (_tmp12_, "category");
#line 369 "../src/SlingshotView.vala"
			_tmp13_ = self->search_entry;
#line 369 "../src/SlingshotView.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
#line 370 "../src/SlingshotView.vala"
			break;
#line 1352 "SlingshotView.c"
		}
#line 349 "../src/SlingshotView.vala"
		case SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW:
#line 1356 "SlingshotView.c"
		{
			GtkRevealer* _tmp14_;
			GtkStack* _tmp15_;
#line 373 "../src/SlingshotView.vala"
			_tmp14_ = self->priv->view_selector_revealer;
#line 373 "../src/SlingshotView.vala"
			gtk_revealer_set_reveal_child (_tmp14_, FALSE);
#line 374 "../src/SlingshotView.vala"
			_tmp15_ = self->stack;
#line 374 "../src/SlingshotView.vala"
			gtk_stack_set_visible_child_name (_tmp15_, "search");
#line 375 "../src/SlingshotView.vala"
			break;
#line 1370 "SlingshotView.c"
		}
		default:
#line 349 "../src/SlingshotView.vala"
		break;
#line 1375 "SlingshotView.c"
	}
}

static void
slingshot_slingshot_view_search_data_free (gpointer _data)
{
	SlingshotSlingshotViewSearchData* _data_;
	_data_ = _data;
#line 20 "../src/SlingshotView.vala"
	_g_object_unref0 (_data_->search_match);
#line 20 "../src/SlingshotView.vala"
	_g_object_unref0 (_data_->target);
#line 20 "../src/SlingshotView.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/SlingshotView.vala"
	g_slice_free (SlingshotSlingshotViewSearchData, _data_);
#line 1392 "SlingshotView.c"
}

static void
slingshot_slingshot_view_search (SlingshotSlingshotView* self,
                                 const gchar* text,
                                 SynapseSearchMatch* search_match,
                                 SynapseMatch* target,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	SlingshotSlingshotViewSearchData* _data_;
	SlingshotSlingshotView* _tmp0_;
	gchar* _tmp1_;
	SynapseSearchMatch* _tmp2_;
	SynapseMatch* _tmp3_;
#line 20 "../src/SlingshotView.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/SlingshotView.vala"
	g_return_if_fail (text != NULL);
#line 20 "../src/SlingshotView.vala"
	_data_ = g_slice_new0 (SlingshotSlingshotViewSearchData);
#line 20 "../src/SlingshotView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/SlingshotView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, slingshot_slingshot_view_search_data_free);
#line 20 "../src/SlingshotView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/SlingshotView.vala"
	_data_->self = _tmp0_;
#line 20 "../src/SlingshotView.vala"
	_tmp1_ = g_strdup (text);
#line 20 "../src/SlingshotView.vala"
	_g_free0 (_data_->text);
#line 20 "../src/SlingshotView.vala"
	_data_->text = _tmp1_;
#line 20 "../src/SlingshotView.vala"
	_tmp2_ = _g_object_ref0 (search_match);
#line 20 "../src/SlingshotView.vala"
	_g_object_unref0 (_data_->search_match);
#line 20 "../src/SlingshotView.vala"
	_data_->search_match = _tmp2_;
#line 20 "../src/SlingshotView.vala"
	_tmp3_ = _g_object_ref0 (target);
#line 20 "../src/SlingshotView.vala"
	_g_object_unref0 (_data_->target);
#line 20 "../src/SlingshotView.vala"
	_data_->target = _tmp3_;
#line 20 "../src/SlingshotView.vala"
	slingshot_slingshot_view_search_co (_data_);
#line 1442 "SlingshotView.c"
}

static void
slingshot_slingshot_view_search_finish (SlingshotSlingshotView* self,
                                        GAsyncResult* _res_)
{
	SlingshotSlingshotViewSearchData* _data_;
#line 20 "../src/SlingshotView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1452 "SlingshotView.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 380 "../src/SlingshotView.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 380 "../src/SlingshotView.vala"
	return _data2_;
#line 1462 "SlingshotView.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 380 "../src/SlingshotView.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1472 "SlingshotView.c"
		SlingshotSlingshotView* self;
#line 380 "../src/SlingshotView.vala"
		self = _data2_->self;
#line 380 "../src/SlingshotView.vala"
		_g_object_unref0 (_data2_->matches);
#line 380 "../src/SlingshotView.vala"
		_g_free0 (_data2_->text);
#line 380 "../src/SlingshotView.vala"
		_g_object_unref0 (self);
#line 380 "../src/SlingshotView.vala"
		g_slice_free (Block2Data, _data2_);
#line 1484 "SlingshotView.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 1506 "SlingshotView.c"
}

static gboolean
___lambda68_ (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 393 "../src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 393 "../src/SlingshotView.vala"
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
#line 393 "../src/SlingshotView.vala"
	_tmp2_ = _tmp1_;
#line 393 "../src/SlingshotView.vala"
	_tmp3_ = string_strip (_tmp2_);
#line 393 "../src/SlingshotView.vala"
	_tmp4_ = _tmp3_;
#line 393 "../src/SlingshotView.vala"
	_tmp5_ = g_strcmp0 (_tmp4_, "") == 0;
#line 393 "../src/SlingshotView.vala"
	_g_free0 (_tmp4_);
#line 393 "../src/SlingshotView.vala"
	if (_tmp5_) {
#line 1535 "SlingshotView.c"
		GraniteWidgetsModeButton* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 394 "../src/SlingshotView.vala"
		_tmp6_ = self->view_selector;
#line 394 "../src/SlingshotView.vala"
		_tmp7_ = granite_widgets_mode_button_get_selected (_tmp6_);
#line 394 "../src/SlingshotView.vala"
		_tmp8_ = _tmp7_;
#line 394 "../src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (self, (SlingshotSlingshotViewModality) _tmp8_);
#line 1547 "SlingshotView.c"
	}
#line 395 "../src/SlingshotView.vala"
	result = FALSE;
#line 395 "../src/SlingshotView.vala"
	return result;
#line 1553 "SlingshotView.c"
}

static gboolean
____lambda68__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda68_ ((SlingshotSlingshotView*) self);
#line 392 "../src/SlingshotView.vala"
	return result;
#line 1563 "SlingshotView.c"
}

static void
slingshot_slingshot_view_search_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	SlingshotSlingshotViewSearchData* _data_;
#line 407 "../src/SlingshotView.vala"
	_data_ = _user_data_;
#line 407 "../src/SlingshotView.vala"
	_data_->_source_object_ = source_object;
#line 407 "../src/SlingshotView.vala"
	_data_->_res_ = _res_;
#line 407 "../src/SlingshotView.vala"
	slingshot_slingshot_view_search_co (_data_);
#line 1580 "SlingshotView.c"
}

static gboolean
__lambda69_ (Block2Data* _data2_)
{
	SlingshotSlingshotView* self;
	SlingshotWidgetsSearchView* _tmp0_;
	GeeList* _tmp1_;
	gboolean result;
#line 412 "../src/SlingshotView.vala"
	self = _data2_->self;
#line 413 "../src/SlingshotView.vala"
	_tmp0_ = self->priv->search_view;
#line 413 "../src/SlingshotView.vala"
	_tmp1_ = _data2_->matches;
#line 413 "../src/SlingshotView.vala"
	slingshot_widgets_search_view_set_results (_tmp0_, _tmp1_, _data2_->text);
#line 414 "../src/SlingshotView.vala"
	result = FALSE;
#line 414 "../src/SlingshotView.vala"
	return result;
#line 1602 "SlingshotView.c"
}

static gboolean
___lambda69__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda69_ (self);
#line 412 "../src/SlingshotView.vala"
	return result;
#line 1612 "SlingshotView.c"
}

static gboolean
slingshot_slingshot_view_search_co (SlingshotSlingshotViewSearchData* _data_)
{
#line 380 "../src/SlingshotView.vala"
	switch (_data_->_state_) {
#line 380 "../src/SlingshotView.vala"
		case 0:
#line 1622 "SlingshotView.c"
		goto _state_0;
#line 380 "../src/SlingshotView.vala"
		case 1:
#line 1626 "SlingshotView.c"
		goto _state_1;
#line 380 "../src/SlingshotView.vala"
		case 2:
#line 1630 "SlingshotView.c"
		goto _state_2;
		default:
#line 380 "../src/SlingshotView.vala"
		g_assert_not_reached ();
#line 1635 "SlingshotView.c"
	}
	_state_0:
#line 380 "../src/SlingshotView.vala"
	_data_->_data2_ = g_slice_new0 (Block2Data);
#line 380 "../src/SlingshotView.vala"
	_data_->_data2_->_ref_count_ = 1;
#line 380 "../src/SlingshotView.vala"
	_data_->_data2_->self = g_object_ref (_data_->self);
#line 380 "../src/SlingshotView.vala"
	_g_free0 (_data_->_data2_->text);
#line 380 "../src/SlingshotView.vala"
	_data_->_data2_->text = _data_->text;
#line 380 "../src/SlingshotView.vala"
	_data_->_data2_->_async_data_ = _data_;
#line 383 "../src/SlingshotView.vala"
	_data_->_tmp0_ = string_strip (_data_->_data2_->text);
#line 383 "../src/SlingshotView.vala"
	_data_->stripped = _data_->_tmp0_;
#line 385 "../src/SlingshotView.vala"
	_data_->_tmp1_ = _data_->stripped;
#line 385 "../src/SlingshotView.vala"
	if (g_strcmp0 (_data_->_tmp1_, "") == 0) {
#line 392 "../src/SlingshotView.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda68__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 397 "../src/SlingshotView.vala"
		_g_free0 (_data_->stripped);
#line 397 "../src/SlingshotView.vala"
		block2_data_unref (_data_->_data2_);
#line 397 "../src/SlingshotView.vala"
		_data_->_data2_ = NULL;
#line 397 "../src/SlingshotView.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 397 "../src/SlingshotView.vala"
		if (_data_->_state_ != 0) {
#line 397 "../src/SlingshotView.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 397 "../src/SlingshotView.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1674 "SlingshotView.c"
			}
		}
#line 397 "../src/SlingshotView.vala"
		g_object_unref (_data_->_async_result);
#line 397 "../src/SlingshotView.vala"
		return FALSE;
#line 1681 "SlingshotView.c"
	}
#line 400 "../src/SlingshotView.vala"
	if (_data_->self->priv->modality != SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW) {
#line 401 "../src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (_data_->self, SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW);
#line 1687 "SlingshotView.c"
	}
#line 405 "../src/SlingshotView.vala"
	if (_data_->search_match != NULL) {
#line 406 "../src/SlingshotView.vala"
		synapse_search_match_set_search_source (_data_->search_match, _data_->target);
#line 407 "../src/SlingshotView.vala"
		_data_->_tmp2_ = _data_->self->priv->synapse;
#line 407 "../src/SlingshotView.vala"
		_data_->_state_ = 1;
#line 407 "../src/SlingshotView.vala"
		slingshot_backend_synapse_search_search (_data_->_tmp2_, _data_->_data2_->text, (SynapseSearchProvider*) _data_->search_match, slingshot_slingshot_view_search_ready, _data_);
#line 407 "../src/SlingshotView.vala"
		return FALSE;
#line 1701 "SlingshotView.c"
		_state_1:
#line 407 "../src/SlingshotView.vala"
		_data_->_tmp3_ = slingshot_backend_synapse_search_search_finish (_data_->_tmp2_, _data_->_res_);
#line 407 "../src/SlingshotView.vala"
		_g_object_unref0 (_data_->_data2_->matches);
#line 407 "../src/SlingshotView.vala"
		_data_->_data2_->matches = _data_->_tmp3_;
#line 1709 "SlingshotView.c"
	} else {
#line 409 "../src/SlingshotView.vala"
		_data_->_tmp4_ = _data_->self->priv->synapse;
#line 409 "../src/SlingshotView.vala"
		_data_->_state_ = 2;
#line 409 "../src/SlingshotView.vala"
		slingshot_backend_synapse_search_search (_data_->_tmp4_, _data_->_data2_->text, NULL, slingshot_slingshot_view_search_ready, _data_);
#line 409 "../src/SlingshotView.vala"
		return FALSE;
#line 1719 "SlingshotView.c"
		_state_2:
#line 409 "../src/SlingshotView.vala"
		_data_->_tmp5_ = slingshot_backend_synapse_search_search_finish (_data_->_tmp4_, _data_->_res_);
#line 409 "../src/SlingshotView.vala"
		_g_object_unref0 (_data_->_data2_->matches);
#line 409 "../src/SlingshotView.vala"
		_data_->_data2_->matches = _data_->_tmp5_;
#line 1727 "SlingshotView.c"
	}
#line 412 "../src/SlingshotView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda69__gsource_func, block2_data_ref (_data_->_data2_), block2_data_unref);
#line 380 "../src/SlingshotView.vala"
	_g_free0 (_data_->stripped);
#line 380 "../src/SlingshotView.vala"
	block2_data_unref (_data_->_data2_);
#line 380 "../src/SlingshotView.vala"
	_data_->_data2_ = NULL;
#line 380 "../src/SlingshotView.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 380 "../src/SlingshotView.vala"
	if (_data_->_state_ != 0) {
#line 380 "../src/SlingshotView.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 380 "../src/SlingshotView.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1745 "SlingshotView.c"
		}
	}
#line 380 "../src/SlingshotView.vala"
	g_object_unref (_data_->_async_result);
#line 380 "../src/SlingshotView.vala"
	return FALSE;
#line 1752 "SlingshotView.c"
}

SlingshotSlingshotView*
slingshot_slingshot_view_construct (GType object_type)
{
	SlingshotSlingshotView * self = NULL;
#line 20 "../src/SlingshotView.vala"
	self = (SlingshotSlingshotView*) g_object_new (object_type, NULL);
#line 20 "../src/SlingshotView.vala"
	return self;
#line 1763 "SlingshotView.c"
}

SlingshotSlingshotView*
slingshot_slingshot_view_new (void)
{
#line 20 "../src/SlingshotView.vala"
	return slingshot_slingshot_view_construct (SLINGSHOT_TYPE_SLINGSHOT_VIEW);
#line 1771 "SlingshotView.c"
}

static GSettings*
slingshot_slingshot_view_get_settings (void)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 47 "../src/SlingshotView.vala"
	_tmp0_ = slingshot_slingshot_view__settings;
#line 47 "../src/SlingshotView.vala"
	result = _tmp0_;
#line 47 "../src/SlingshotView.vala"
	return result;
#line 1785 "SlingshotView.c"
}

static void
slingshot_slingshot_view_set_settings (GSettings* value)
{
	GSettings* _tmp0_;
#line 47 "../src/SlingshotView.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 47 "../src/SlingshotView.vala"
	_g_object_unref0 (slingshot_slingshot_view__settings);
#line 47 "../src/SlingshotView.vala"
	slingshot_slingshot_view__settings = _tmp0_;
#line 1798 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda70_ (SlingshotSlingshotView* self,
                                       SynapseSearchMatch* match,
                                       SynapseMatch* target)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 124 "../src/SlingshotView.vala"
	g_return_if_fail (match != NULL);
#line 125 "../src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 125 "../src/SlingshotView.vala"
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
#line 125 "../src/SlingshotView.vala"
	_tmp2_ = _tmp1_;
#line 125 "../src/SlingshotView.vala"
	slingshot_slingshot_view_search (self, _tmp2_, match, target, NULL, NULL);
#line 1819 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda70__slingshot_widgets_search_view_start_search (SlingshotWidgetsSearchView* _sender,
                                                                                   SynapseSearchMatch* search_match,
                                                                                   SynapseMatch* target,
                                                                                   gpointer self)
{
#line 124 "../src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda70_ ((SlingshotSlingshotView*) self, search_match, target);
#line 1830 "SlingshotView.c"
}

static gboolean
_slingshot_slingshot_view___lambda71_ (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
	gboolean result;
#line 129 "../src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 129 "../src/SlingshotView.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 130 "../src/SlingshotView.vala"
	result = GDK_EVENT_PROPAGATE;
#line 130 "../src/SlingshotView.vala"
	return result;
#line 1846 "SlingshotView.c"
}

static gboolean
__slingshot_slingshot_view___lambda71__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                  GdkEventFocus* event,
                                                                  gpointer self)
{
	gboolean result;
	result = _slingshot_slingshot_view___lambda71_ ((SlingshotSlingshotView*) self);
#line 128 "../src/SlingshotView.vala"
	return result;
#line 1858 "SlingshotView.c"
}

static gboolean
_slingshot_slingshot_view_on_event_box_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                             GdkEventKey* event,
                                                                             gpointer self)
{
	gboolean result;
	result = slingshot_slingshot_view_on_event_box_key_press ((SlingshotSlingshotView*) self, event);
#line 133 "../src/SlingshotView.vala"
	return result;
#line 1870 "SlingshotView.c"
}

static gboolean
_slingshot_slingshot_view_on_search_view_key_press_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                               GdkEventKey* event,
                                                                               gpointer self)
{
	gboolean result;
	result = slingshot_slingshot_view_on_search_view_key_press ((SlingshotSlingshotView*) self, event);
#line 134 "../src/SlingshotView.vala"
	return result;
#line 1882 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda72_ (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 138 "../src/SlingshotView.vala"
	if (self->priv->modality != SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW) {
#line 139 "../src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (self, SLINGSHOT_SLINGSHOT_VIEW_MODALITY_SEARCH_VIEW);
#line 1895 "SlingshotView.c"
	}
#line 141 "../src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 141 "../src/SlingshotView.vala"
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
#line 141 "../src/SlingshotView.vala"
	_tmp2_ = _tmp1_;
#line 141 "../src/SlingshotView.vala"
	slingshot_slingshot_view_search (self, _tmp2_, NULL, NULL, NULL, NULL);
#line 1905 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda72__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                        gpointer self)
{
#line 137 "../src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda72_ ((SlingshotSlingshotView*) self);
#line 1914 "SlingshotView.c"
}

static void
_slingshot_slingshot_view_search_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                     gpointer self)
{
#line 145 "../src/SlingshotView.vala"
	slingshot_slingshot_view_search_entry_activated ((SlingshotSlingshotView*) self);
#line 1923 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda73_ (SlingshotSlingshotView* self)
{
	GtkSearchEntry* _tmp0_;
#line 148 "../src/SlingshotView.vala"
	_tmp0_ = self->search_entry;
#line 148 "../src/SlingshotView.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 1934 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda73__slingshot_widgets_category_view_search_focus_request (SlingshotWidgetsCategoryView* _sender,
                                                                                             gpointer self)
{
#line 147 "../src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda73_ ((SlingshotSlingshotView*) self);
#line 1943 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda74_ (SlingshotSlingshotView* self)
{
#line 152 "../src/SlingshotView.vala"
	g_signal_emit (self, slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL], 0);
#line 1951 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda74__slingshot_widgets_grid_app_launched (SlingshotWidgetsGrid* _sender,
                                                                            gpointer self)
{
#line 151 "../src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda74_ ((SlingshotSlingshotView*) self);
#line 1960 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda75_ (SlingshotSlingshotView* self)
{
#line 156 "../src/SlingshotView.vala"
	g_signal_emit (self, slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL], 0);
#line 1968 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda75__slingshot_widgets_search_view_app_launched (SlingshotWidgetsSearchView* _sender,
                                                                                   gpointer self)
{
#line 155 "../src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda75_ ((SlingshotSlingshotView*) self);
#line 1977 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda76_ (SlingshotSlingshotView* self)
{
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 160 "../src/SlingshotView.vala"
	_tmp0_ = self->view_selector;
#line 160 "../src/SlingshotView.vala"
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
#line 160 "../src/SlingshotView.vala"
	_tmp2_ = _tmp1_;
#line 160 "../src/SlingshotView.vala"
	slingshot_slingshot_view_set_modality (self, (SlingshotSlingshotViewModality) _tmp2_);
#line 1994 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda76__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                                 GtkWidget* widget,
                                                                                 gpointer self)
{
#line 159 "../src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda76_ ((SlingshotSlingshotView*) self);
#line 2004 "SlingshotView.c"
}

static void
_slingshot_slingshot_view___lambda77_ (SlingshotSlingshotView* self)
{
	SlingshotWidgetsGrid* _tmp0_;
	SlingshotBackendAppSystem* _tmp1_;
	SlingshotWidgetsCategoryView* _tmp2_;
#line 165 "../src/SlingshotView.vala"
	_tmp0_ = self->priv->grid_view;
#line 165 "../src/SlingshotView.vala"
	_tmp1_ = self->app_system;
#line 165 "../src/SlingshotView.vala"
	slingshot_widgets_grid_populate (_tmp0_, _tmp1_);
#line 167 "../src/SlingshotView.vala"
	_tmp2_ = self->priv->category_view;
#line 167 "../src/SlingshotView.vala"
	slingshot_widgets_category_view_setup_sidebar (_tmp2_);
#line 2023 "SlingshotView.c"
}

static void
__slingshot_slingshot_view___lambda77__slingshot_backend_app_system_changed (SlingshotBackendAppSystem* _sender,
                                                                             gpointer self)
{
#line 164 "../src/SlingshotView.vala"
	_slingshot_slingshot_view___lambda77_ ((SlingshotSlingshotView*) self);
#line 2032 "SlingshotView.c"
}

static GObject *
slingshot_slingshot_view_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlingshotSlingshotView * self;
	SlingshotBackendAppSystem* _tmp0_;
	SlingshotBackendSynapseSearch* _tmp1_;
	GdkScreen* _tmp2_;
	GdkScreen* _tmp3_;
	GtkImage* grid_image = NULL;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkImage* category_image = NULL;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GraniteWidgetsModeButton* _tmp18_;
	GraniteWidgetsModeButton* _tmp19_;
	GraniteWidgetsModeButton* _tmp20_;
	GtkImage* _tmp21_;
	GraniteWidgetsModeButton* _tmp22_;
	GtkImage* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkRevealer* _tmp25_;
	GtkRevealer* _tmp26_;
	GraniteWidgetsModeButton* _tmp27_;
	GtkSearchEntry* _tmp28_;
	GtkSearchEntry* _tmp29_;
	GtkSearchEntry* _tmp30_;
	GtkSearchEntry* _tmp31_;
	gchar* _tmp32_;
	gchar** _tmp33_;
	gchar** _tmp34_;
	gint _tmp34__length1;
	gchar* _tmp35_;
	gchar* _tmp36_;
	GtkGrid* top = NULL;
	GtkGrid* _tmp37_;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	GtkGrid* _tmp40_;
	GtkRevealer* _tmp41_;
	GtkGrid* _tmp42_;
	GtkSearchEntry* _tmp43_;
	SlingshotWidgetsGrid* _tmp44_;
	SlingshotWidgetsCategoryView* _tmp45_;
	SlingshotWidgetsSearchView* _tmp46_;
	GtkStack* _tmp47_ = NULL;
	GtkStack* _tmp48_;
	SlingshotWidgetsGrid* _tmp49_;
	GtkStack* _tmp50_;
	SlingshotWidgetsCategoryView* _tmp51_;
	GtkStack* _tmp52_;
	SlingshotWidgetsSearchView* _tmp53_;
	GtkGrid* container = NULL;
	GtkGrid* _tmp54_;
	GtkGrid* _tmp55_;
	GtkGrid* _tmp56_;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkStack* _tmp60_;
	SlingshotWidgetsGrid* _tmp61_;
	SlingshotBackendAppSystem* _tmp62_;
	GtkEventBox* event_box = NULL;
	GtkEventBox* _tmp63_;
	GtkEventBox* _tmp64_;
	GtkGrid* _tmp65_;
	GtkEventBox* _tmp66_;
	GSettings* _tmp67_;
	GSettings* _tmp68_;
	SlingshotWidgetsSearchView* _tmp71_;
	GtkEventBox* _tmp72_;
	GtkSearchEntry* _tmp73_;
	GtkSearchEntry* _tmp74_;
	GtkSearchEntry* _tmp75_;
	GtkSearchEntry* _tmp76_;
	SlingshotWidgetsCategoryView* _tmp77_;
	SlingshotWidgetsGrid* _tmp78_;
	SlingshotWidgetsSearchView* _tmp79_;
	GraniteWidgetsModeButton* _tmp80_;
	SlingshotBackendAppSystem* _tmp81_;
#line 53 "../src/SlingshotView.vala"
	parent_class = G_OBJECT_CLASS (slingshot_slingshot_view_parent_class);
#line 53 "../src/SlingshotView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 53 "../src/SlingshotView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_TYPE_SLINGSHOT_VIEW, SlingshotSlingshotView);
#line 54 "../src/SlingshotView.vala"
	_tmp0_ = slingshot_backend_app_system_new ();
#line 54 "../src/SlingshotView.vala"
	_g_object_unref0 (self->app_system);
#line 54 "../src/SlingshotView.vala"
	self->app_system = _tmp0_;
#line 55 "../src/SlingshotView.vala"
	_tmp1_ = slingshot_backend_synapse_search_new ();
#line 55 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->synapse);
#line 55 "../src/SlingshotView.vala"
	self->priv->synapse = _tmp1_;
#line 57 "../src/SlingshotView.vala"
	_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 57 "../src/SlingshotView.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 57 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->screen);
#line 57 "../src/SlingshotView.vala"
	self->priv->screen = _tmp3_;
#line 59 "../src/SlingshotView.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("view-grid-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 59 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp4_);
#line 59 "../src/SlingshotView.vala"
	grid_image = _tmp4_;
#line 60 "../src/SlingshotView.vala"
	_tmp5_ = grid_image;
#line 60 "../src/SlingshotView.vala"
	_tmp6_ = g_strdup ("<Ctrl>1");
#line 60 "../src/SlingshotView.vala"
	_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 60 "../src/SlingshotView.vala"
	_tmp7_[0] = _tmp6_;
#line 60 "../src/SlingshotView.vala"
	_tmp8_ = _tmp7_;
#line 60 "../src/SlingshotView.vala"
	_tmp8__length1 = 1;
#line 60 "../src/SlingshotView.vala"
	_tmp9_ = granite_markup_accel_tooltip (_tmp8_, (gint) 1, _ ("View as Grid"));
#line 60 "../src/SlingshotView.vala"
	_tmp10_ = _tmp9_;
#line 60 "../src/SlingshotView.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp5_, _tmp10_);
#line 60 "../src/SlingshotView.vala"
	_g_free0 (_tmp10_);
#line 60 "../src/SlingshotView.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 62 "../src/SlingshotView.vala"
	_tmp11_ = (GtkImage*) gtk_image_new_from_icon_name ("view-filter-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 62 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp11_);
#line 62 "../src/SlingshotView.vala"
	category_image = _tmp11_;
#line 63 "../src/SlingshotView.vala"
	_tmp12_ = category_image;
#line 63 "../src/SlingshotView.vala"
	_tmp13_ = g_strdup ("<Ctrl>2");
#line 63 "../src/SlingshotView.vala"
	_tmp14_ = g_new0 (gchar*, 1 + 1);
#line 63 "../src/SlingshotView.vala"
	_tmp14_[0] = _tmp13_;
#line 63 "../src/SlingshotView.vala"
	_tmp15_ = _tmp14_;
#line 63 "../src/SlingshotView.vala"
	_tmp15__length1 = 1;
#line 63 "../src/SlingshotView.vala"
	_tmp16_ = granite_markup_accel_tooltip (_tmp15_, (gint) 1, _ ("View by Category"));
#line 63 "../src/SlingshotView.vala"
	_tmp17_ = _tmp16_;
#line 63 "../src/SlingshotView.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp12_, _tmp17_);
#line 63 "../src/SlingshotView.vala"
	_g_free0 (_tmp17_);
#line 63 "../src/SlingshotView.vala"
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 65 "../src/SlingshotView.vala"
	_tmp18_ = granite_widgets_mode_button_new ();
#line 65 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp18_);
#line 65 "../src/SlingshotView.vala"
	_g_object_unref0 (self->view_selector);
#line 65 "../src/SlingshotView.vala"
	self->view_selector = _tmp18_;
#line 66 "../src/SlingshotView.vala"
	_tmp19_ = self->view_selector;
#line 66 "../src/SlingshotView.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp19_, 12);
#line 67 "../src/SlingshotView.vala"
	_tmp20_ = self->view_selector;
#line 67 "../src/SlingshotView.vala"
	_tmp21_ = grid_image;
#line 67 "../src/SlingshotView.vala"
	granite_widgets_mode_button_append (_tmp20_, (GtkWidget*) _tmp21_);
#line 68 "../src/SlingshotView.vala"
	_tmp22_ = self->view_selector;
#line 68 "../src/SlingshotView.vala"
	_tmp23_ = category_image;
#line 68 "../src/SlingshotView.vala"
	granite_widgets_mode_button_append (_tmp22_, (GtkWidget*) _tmp23_);
#line 70 "../src/SlingshotView.vala"
	_tmp24_ = (GtkRevealer*) gtk_revealer_new ();
#line 70 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp24_);
#line 70 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->view_selector_revealer);
#line 70 "../src/SlingshotView.vala"
	self->priv->view_selector_revealer = _tmp24_;
#line 71 "../src/SlingshotView.vala"
	_tmp25_ = self->priv->view_selector_revealer;
#line 71 "../src/SlingshotView.vala"
	gtk_revealer_set_transition_type (_tmp25_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
#line 72 "../src/SlingshotView.vala"
	_tmp26_ = self->priv->view_selector_revealer;
#line 72 "../src/SlingshotView.vala"
	_tmp27_ = self->view_selector;
#line 72 "../src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 74 "../src/SlingshotView.vala"
	_tmp28_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 74 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp28_);
#line 74 "../src/SlingshotView.vala"
	_g_object_unref0 (self->search_entry);
#line 74 "../src/SlingshotView.vala"
	self->search_entry = _tmp28_;
#line 75 "../src/SlingshotView.vala"
	_tmp29_ = self->search_entry;
#line 75 "../src/SlingshotView.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp29_, _ ("Search Apps"));
#line 76 "../src/SlingshotView.vala"
	_tmp30_ = self->search_entry;
#line 76 "../src/SlingshotView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp30_, TRUE);
#line 77 "../src/SlingshotView.vala"
	_tmp31_ = self->search_entry;
#line 77 "../src/SlingshotView.vala"
	_tmp32_ = g_strdup ("<Ctrl>BackSpace");
#line 77 "../src/SlingshotView.vala"
	_tmp33_ = g_new0 (gchar*, 1 + 1);
#line 77 "../src/SlingshotView.vala"
	_tmp33_[0] = _tmp32_;
#line 77 "../src/SlingshotView.vala"
	_tmp34_ = _tmp33_;
#line 77 "../src/SlingshotView.vala"
	_tmp34__length1 = 1;
#line 77 "../src/SlingshotView.vala"
	_tmp35_ = granite_markup_accel_tooltip (_tmp34_, (gint) 1, _ ("Clear all"));
#line 77 "../src/SlingshotView.vala"
	_tmp36_ = _tmp35_;
#line 77 "../src/SlingshotView.vala"
	g_object_set ((GtkEntry*) _tmp31_, "secondary-icon-tooltip-markup", _tmp36_, NULL);
#line 77 "../src/SlingshotView.vala"
	_g_free0 (_tmp36_);
#line 77 "../src/SlingshotView.vala"
	_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/SlingshotView.vala"
	_tmp37_ = (GtkGrid*) gtk_grid_new ();
#line 81 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp37_);
#line 81 "../src/SlingshotView.vala"
	top = _tmp37_;
#line 82 "../src/SlingshotView.vala"
	_tmp38_ = top;
#line 82 "../src/SlingshotView.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp38_, 12);
#line 83 "../src/SlingshotView.vala"
	_tmp39_ = top;
#line 83 "../src/SlingshotView.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp39_, 12);
#line 84 "../src/SlingshotView.vala"
	_tmp40_ = top;
#line 84 "../src/SlingshotView.vala"
	_tmp41_ = self->priv->view_selector_revealer;
#line 84 "../src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp41_);
#line 85 "../src/SlingshotView.vala"
	_tmp42_ = top;
#line 85 "../src/SlingshotView.vala"
	_tmp43_ = self->search_entry;
#line 85 "../src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp43_);
#line 87 "../src/SlingshotView.vala"
	_tmp44_ = slingshot_widgets_grid_new ();
#line 87 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp44_);
#line 87 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->grid_view);
#line 87 "../src/SlingshotView.vala"
	self->priv->grid_view = _tmp44_;
#line 89 "../src/SlingshotView.vala"
	_tmp45_ = slingshot_widgets_category_view_new (self);
#line 89 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp45_);
#line 89 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->category_view);
#line 89 "../src/SlingshotView.vala"
	self->priv->category_view = _tmp45_;
#line 91 "../src/SlingshotView.vala"
	_tmp46_ = slingshot_widgets_search_view_new ();
#line 91 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp46_);
#line 91 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->search_view);
#line 91 "../src/SlingshotView.vala"
	self->priv->search_view = _tmp46_;
#line 93 "../src/SlingshotView.vala"
	_tmp47_ = (GtkStack*) gtk_stack_new ();
#line 93 "../src/SlingshotView.vala"
	gtk_stack_set_transition_duration (_tmp47_, (guint) GRANITE_TRANSITION_DURATION_IN_PLACE);
#line 93 "../src/SlingshotView.vala"
	gtk_stack_set_transition_type (_tmp47_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 93 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp47_);
#line 93 "../src/SlingshotView.vala"
	_g_object_unref0 (self->stack);
#line 93 "../src/SlingshotView.vala"
	self->stack = _tmp47_;
#line 97 "../src/SlingshotView.vala"
	_tmp48_ = self->stack;
#line 97 "../src/SlingshotView.vala"
	_tmp49_ = self->priv->grid_view;
#line 97 "../src/SlingshotView.vala"
	gtk_stack_add_named (_tmp48_, (GtkWidget*) _tmp49_, "normal");
#line 98 "../src/SlingshotView.vala"
	_tmp50_ = self->stack;
#line 98 "../src/SlingshotView.vala"
	_tmp51_ = self->priv->category_view;
#line 98 "../src/SlingshotView.vala"
	gtk_stack_add_named (_tmp50_, (GtkWidget*) _tmp51_, "category");
#line 99 "../src/SlingshotView.vala"
	_tmp52_ = self->stack;
#line 99 "../src/SlingshotView.vala"
	_tmp53_ = self->priv->search_view;
#line 99 "../src/SlingshotView.vala"
	gtk_stack_add_named (_tmp52_, (GtkWidget*) _tmp53_, "search");
#line 101 "../src/SlingshotView.vala"
	_tmp54_ = (GtkGrid*) gtk_grid_new ();
#line 101 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp54_);
#line 101 "../src/SlingshotView.vala"
	container = _tmp54_;
#line 102 "../src/SlingshotView.vala"
	_tmp55_ = container;
#line 102 "../src/SlingshotView.vala"
	gtk_grid_set_row_spacing (_tmp55_, 12);
#line 103 "../src/SlingshotView.vala"
	_tmp56_ = container;
#line 103 "../src/SlingshotView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp56_, 12);
#line 104 "../src/SlingshotView.vala"
	_tmp57_ = container;
#line 104 "../src/SlingshotView.vala"
	_tmp58_ = top;
#line 104 "../src/SlingshotView.vala"
	gtk_grid_attach (_tmp57_, (GtkWidget*) _tmp58_, 0, 0, 1, 1);
#line 105 "../src/SlingshotView.vala"
	_tmp59_ = container;
#line 105 "../src/SlingshotView.vala"
	_tmp60_ = self->stack;
#line 105 "../src/SlingshotView.vala"
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 0, 1, 1, 1);
#line 108 "../src/SlingshotView.vala"
	_tmp61_ = self->priv->grid_view;
#line 108 "../src/SlingshotView.vala"
	_tmp62_ = self->app_system;
#line 108 "../src/SlingshotView.vala"
	slingshot_widgets_grid_populate (_tmp61_, _tmp62_);
#line 110 "../src/SlingshotView.vala"
	_tmp63_ = (GtkEventBox*) gtk_event_box_new ();
#line 110 "../src/SlingshotView.vala"
	g_object_ref_sink (_tmp63_);
#line 110 "../src/SlingshotView.vala"
	event_box = _tmp63_;
#line 111 "../src/SlingshotView.vala"
	_tmp64_ = event_box;
#line 111 "../src/SlingshotView.vala"
	_tmp65_ = container;
#line 111 "../src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) _tmp64_, (GtkWidget*) _tmp65_);
#line 114 "../src/SlingshotView.vala"
	_tmp66_ = event_box;
#line 114 "../src/SlingshotView.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp66_);
#line 116 "../src/SlingshotView.vala"
	_tmp67_ = slingshot_slingshot_view_get_settings ();
#line 116 "../src/SlingshotView.vala"
	_tmp68_ = _tmp67_;
#line 116 "../src/SlingshotView.vala"
	if (g_settings_get_boolean (_tmp68_, "use-category")) {
#line 2427 "SlingshotView.c"
		GraniteWidgetsModeButton* _tmp69_;
#line 117 "../src/SlingshotView.vala"
		_tmp69_ = self->view_selector;
#line 117 "../src/SlingshotView.vala"
		granite_widgets_mode_button_set_selected (_tmp69_, 1);
#line 118 "../src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (self, SLINGSHOT_SLINGSHOT_VIEW_MODALITY_CATEGORY_VIEW);
#line 2435 "SlingshotView.c"
	} else {
		GraniteWidgetsModeButton* _tmp70_;
#line 120 "../src/SlingshotView.vala"
		_tmp70_ = self->view_selector;
#line 120 "../src/SlingshotView.vala"
		granite_widgets_mode_button_set_selected (_tmp70_, 0);
#line 121 "../src/SlingshotView.vala"
		slingshot_slingshot_view_set_modality (self, SLINGSHOT_SLINGSHOT_VIEW_MODALITY_NORMAL_VIEW);
#line 2444 "SlingshotView.c"
	}
#line 124 "../src/SlingshotView.vala"
	_tmp71_ = self->priv->search_view;
#line 124 "../src/SlingshotView.vala"
	g_signal_connect_object (_tmp71_, "start-search", (GCallback) __slingshot_slingshot_view___lambda70__slingshot_widgets_search_view_start_search, self, 0);
#line 128 "../src/SlingshotView.vala"
	g_signal_connect_object ((GtkWidget*) self, "focus-in-event", (GCallback) __slingshot_slingshot_view___lambda71__gtk_widget_focus_in_event, self, 0);
#line 133 "../src/SlingshotView.vala"
	_tmp72_ = event_box;
#line 133 "../src/SlingshotView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp72_, "key-press-event", (GCallback) _slingshot_slingshot_view_on_event_box_key_press_gtk_widget_key_press_event, self, 0);
#line 134 "../src/SlingshotView.vala"
	_tmp73_ = self->search_entry;
#line 134 "../src/SlingshotView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp73_, "key-press-event", (GCallback) _slingshot_slingshot_view_on_search_view_key_press_gtk_widget_key_press_event, self, 0);
#line 137 "../src/SlingshotView.vala"
	_tmp74_ = self->search_entry;
#line 137 "../src/SlingshotView.vala"
	g_signal_connect_object (_tmp74_, "search-changed", (GCallback) __slingshot_slingshot_view___lambda72__gtk_search_entry_search_changed, self, 0);
#line 144 "../src/SlingshotView.vala"
	_tmp75_ = self->search_entry;
#line 144 "../src/SlingshotView.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp75_);
#line 145 "../src/SlingshotView.vala"
	_tmp76_ = self->search_entry;
#line 145 "../src/SlingshotView.vala"
	g_signal_connect_object ((GtkEntry*) _tmp76_, "activate", (GCallback) _slingshot_slingshot_view_search_entry_activated_gtk_entry_activate, self, 0);
#line 147 "../src/SlingshotView.vala"
	_tmp77_ = self->priv->category_view;
#line 147 "../src/SlingshotView.vala"
	g_signal_connect_object (_tmp77_, "search-focus-request", (GCallback) __slingshot_slingshot_view___lambda73__slingshot_widgets_category_view_search_focus_request, self, 0);
#line 151 "../src/SlingshotView.vala"
	_tmp78_ = self->priv->grid_view;
#line 151 "../src/SlingshotView.vala"
	g_signal_connect_object (_tmp78_, "app-launched", (GCallback) __slingshot_slingshot_view___lambda74__slingshot_widgets_grid_app_launched, self, 0);
#line 155 "../src/SlingshotView.vala"
	_tmp79_ = self->priv->search_view;
#line 155 "../src/SlingshotView.vala"
	g_signal_connect_object (_tmp79_, "app-launched", (GCallback) __slingshot_slingshot_view___lambda75__slingshot_widgets_search_view_app_launched, self, 0);
#line 159 "../src/SlingshotView.vala"
	_tmp80_ = self->view_selector;
#line 159 "../src/SlingshotView.vala"
	g_signal_connect_object (_tmp80_, "mode-changed", (GCallback) __slingshot_slingshot_view___lambda76__granite_widgets_mode_button_mode_changed, self, 0);
#line 164 "../src/SlingshotView.vala"
	_tmp81_ = self->app_system;
#line 164 "../src/SlingshotView.vala"
	g_signal_connect_object (_tmp81_, "changed", (GCallback) __slingshot_slingshot_view___lambda77__slingshot_backend_app_system_changed, self, 0);
#line 53 "../src/SlingshotView.vala"
	_g_object_unref0 (event_box);
#line 53 "../src/SlingshotView.vala"
	_g_object_unref0 (container);
#line 53 "../src/SlingshotView.vala"
	_g_object_unref0 (top);
#line 53 "../src/SlingshotView.vala"
	_g_object_unref0 (category_image);
#line 53 "../src/SlingshotView.vala"
	_g_object_unref0 (grid_image);
#line 53 "../src/SlingshotView.vala"
	return obj;
#line 2504 "SlingshotView.c"
}

static void
slingshot_slingshot_view_class_init (SlingshotSlingshotViewClass * klass,
                                     gpointer klass_data)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 20 "../src/SlingshotView.vala"
	slingshot_slingshot_view_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/SlingshotView.vala"
	g_type_class_adjust_private_offset (klass, &SlingshotSlingshotView_private_offset);
#line 20 "../src/SlingshotView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_slingshot_slingshot_view_get_property;
#line 20 "../src/SlingshotView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_slingshot_slingshot_view_set_property;
#line 20 "../src/SlingshotView.vala"
	G_OBJECT_CLASS (klass)->constructor = slingshot_slingshot_view_constructor;
#line 20 "../src/SlingshotView.vala"
	G_OBJECT_CLASS (klass)->finalize = slingshot_slingshot_view_finalize;
#line 20 "../src/SlingshotView.vala"
	slingshot_slingshot_view_signals[SLINGSHOT_SLINGSHOT_VIEW_CLOSE_INDICATOR_SIGNAL] = g_signal_new ("close-indicator", SLINGSHOT_TYPE_SLINGSHOT_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 50 "../src/SlingshotView.vala"
	_tmp0_ = g_settings_new ("io.elementary.desktop.wingpanel.applications-menu");
#line 50 "../src/SlingshotView.vala"
	_tmp1_ = _tmp0_;
#line 50 "../src/SlingshotView.vala"
	slingshot_slingshot_view_set_settings (_tmp1_);
#line 50 "../src/SlingshotView.vala"
	_g_object_unref0 (_tmp1_);
#line 2535 "SlingshotView.c"
}

static void
slingshot_slingshot_view_plank_unity_client_interface_init (PlankUnityClientIface * iface,
                                                            gpointer iface_data)
{
#line 20 "../src/SlingshotView.vala"
	slingshot_slingshot_view_plank_unity_client_parent_iface = g_type_interface_peek_parent (iface);
#line 20 "../src/SlingshotView.vala"
	iface->update_launcher_entry = (void (*) (PlankUnityClient*, const gchar*, GVariant*, gboolean)) slingshot_slingshot_view_real_update_launcher_entry;
#line 20 "../src/SlingshotView.vala"
	iface->remove_launcher_entry = (void (*) (PlankUnityClient*, const gchar*)) slingshot_slingshot_view_real_remove_launcher_entry;
#line 2548 "SlingshotView.c"
}

static void
slingshot_slingshot_view_instance_init (SlingshotSlingshotView * self,
                                        gpointer klass)
{
#line 20 "../src/SlingshotView.vala"
	self->priv = slingshot_slingshot_view_get_instance_private (self);
#line 2557 "SlingshotView.c"
}

static void
slingshot_slingshot_view_finalize (GObject * obj)
{
	SlingshotSlingshotView * self;
#line 20 "../src/SlingshotView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_TYPE_SLINGSHOT_VIEW, SlingshotSlingshotView);
#line 26 "../src/SlingshotView.vala"
	_g_object_unref0 (self->app_system);
#line 27 "../src/SlingshotView.vala"
	_g_object_unref0 (self->search_entry);
#line 28 "../src/SlingshotView.vala"
	_g_object_unref0 (self->stack);
#line 29 "../src/SlingshotView.vala"
	_g_object_unref0 (self->view_selector);
#line 39 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->synapse);
#line 40 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->screen);
#line 41 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->view_selector_revealer);
#line 43 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->grid_view);
#line 44 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->search_view);
#line 45 "../src/SlingshotView.vala"
	_g_object_unref0 (self->priv->category_view);
#line 20 "../src/SlingshotView.vala"
	G_OBJECT_CLASS (slingshot_slingshot_view_parent_class)->finalize (obj);
#line 2588 "SlingshotView.c"
}

static GType
slingshot_slingshot_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlingshotSlingshotViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slingshot_slingshot_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlingshotSlingshotView), 0, (GInstanceInitFunc) slingshot_slingshot_view_instance_init, NULL };
	static const GInterfaceInfo plank_unity_client_info = { (GInterfaceInitFunc) slingshot_slingshot_view_plank_unity_client_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType slingshot_slingshot_view_type_id;
	slingshot_slingshot_view_type_id = g_type_register_static (gtk_grid_get_type (), "SlingshotSlingshotView", &g_define_type_info, 0);
	g_type_add_interface_static (slingshot_slingshot_view_type_id, PLANK_TYPE_UNITY_CLIENT, &plank_unity_client_info);
	SlingshotSlingshotView_private_offset = g_type_add_instance_private (slingshot_slingshot_view_type_id, sizeof (SlingshotSlingshotViewPrivate));
	return slingshot_slingshot_view_type_id;
}

GType
slingshot_slingshot_view_get_type (void)
{
	static volatile gsize slingshot_slingshot_view_type_id__once = 0;
	if (g_once_init_enter (&slingshot_slingshot_view_type_id__once)) {
		GType slingshot_slingshot_view_type_id;
		slingshot_slingshot_view_type_id = slingshot_slingshot_view_get_type_once ();
		g_once_init_leave (&slingshot_slingshot_view_type_id__once, slingshot_slingshot_view_type_id);
	}
	return slingshot_slingshot_view_type_id__once;
}

static void
_vala_slingshot_slingshot_view_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	SlingshotSlingshotView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_TYPE_SLINGSHOT_VIEW, SlingshotSlingshotView);
#line 20 "../src/SlingshotView.vala"
	switch (property_id) {
#line 2625 "SlingshotView.c"
		default:
#line 20 "../src/SlingshotView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/SlingshotView.vala"
		break;
#line 2631 "SlingshotView.c"
	}
}

static void
_vala_slingshot_slingshot_view_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	SlingshotSlingshotView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_TYPE_SLINGSHOT_VIEW, SlingshotSlingshotView);
#line 20 "../src/SlingshotView.vala"
	switch (property_id) {
#line 2645 "SlingshotView.c"
		default:
#line 20 "../src/SlingshotView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/SlingshotView.vala"
		break;
#line 2651 "SlingshotView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

