/* ClipboardCopyAction.c generated by valac 0.56.7, the Vala compiler
 * generated from ClipboardCopyAction.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2017 elementary LLC.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*/

#include "slingshot.h"
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#define SYNAPSE_TYPE_CLIPBOARD_COPY_ACTION (synapse_clipboard_copy_action_get_type ())
#define SYNAPSE_CLIPBOARD_COPY_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SYNAPSE_TYPE_CLIPBOARD_COPY_ACTION, SynapseClipboardCopyAction))
#define SYNAPSE_CLIPBOARD_COPY_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SYNAPSE_TYPE_CLIPBOARD_COPY_ACTION, SynapseClipboardCopyActionClass))
#define SYNAPSE_IS_CLIPBOARD_COPY_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SYNAPSE_TYPE_CLIPBOARD_COPY_ACTION))
#define SYNAPSE_IS_CLIPBOARD_COPY_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SYNAPSE_TYPE_CLIPBOARD_COPY_ACTION))
#define SYNAPSE_CLIPBOARD_COPY_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SYNAPSE_TYPE_CLIPBOARD_COPY_ACTION, SynapseClipboardCopyActionClass))

typedef struct _SynapseClipboardCopyAction SynapseClipboardCopyAction;
typedef struct _SynapseClipboardCopyActionClass SynapseClipboardCopyActionClass;
typedef struct _SynapseClipboardCopyActionPrivate SynapseClipboardCopyActionPrivate;
enum  {
	SYNAPSE_CLIPBOARD_COPY_ACTION_0_PROPERTY,
	SYNAPSE_CLIPBOARD_COPY_ACTION_NUM_PROPERTIES
};
static GParamSpec* synapse_clipboard_copy_action_properties[SYNAPSE_CLIPBOARD_COPY_ACTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SynapseClipboardCopyAction {
	SynapseBaseAction parent_instance;
	SynapseClipboardCopyActionPrivate * priv;
};

struct _SynapseClipboardCopyActionClass {
	SynapseBaseActionClass parent_class;
};

static gpointer synapse_clipboard_copy_action_parent_class = NULL;

VALA_EXTERN GType synapse_clipboard_copy_action_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SynapseClipboardCopyAction* synapse_clipboard_copy_action_new (void);
VALA_EXTERN SynapseClipboardCopyAction* synapse_clipboard_copy_action_construct (GType object_type);
static void synapse_clipboard_copy_action_real_do_execute (SynapseBaseAction* base,
                                                    SynapseMatch* match,
                                                    SynapseMatch* target);
static gboolean synapse_clipboard_copy_action_real_valid_for_match (SynapseBaseAction* base,
                                                             SynapseMatch* match);
static gint synapse_clipboard_copy_action_real_get_relevancy_for_match (SynapseBaseAction* base,
                                                                 SynapseMatch* match);
static GType synapse_clipboard_copy_action_get_type_once (void);

SynapseClipboardCopyAction*
synapse_clipboard_copy_action_construct (GType object_type)
{
	SynapseClipboardCopyAction * self = NULL;
#line 25 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	self = (SynapseClipboardCopyAction*) g_object_new (object_type, "title", _ ("Copy to Clipboard"), "description", _ ("Copy selection to clipboard"), "icon-name", "gtk-copy", "has-thumbnail", FALSE, "match-type", SYNAPSE_MATCH_TYPE_ACTION, "default-relevancy", SYNAPSE_MATCH_SCORE_AVERAGE, NULL);
#line 24 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	return self;
#line 84 "ClipboardCopyAction.c"
}

SynapseClipboardCopyAction*
synapse_clipboard_copy_action_new (void)
{
#line 24 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	return synapse_clipboard_copy_action_construct (SYNAPSE_TYPE_CLIPBOARD_COPY_ACTION);
#line 92 "ClipboardCopyAction.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	return self ? g_object_ref (self) : NULL;
#line 100 "ClipboardCopyAction.c"
}

static void
synapse_clipboard_copy_action_real_do_execute (SynapseBaseAction* base,
                                               SynapseMatch* match,
                                               SynapseMatch* target)
{
	SynapseClipboardCopyAction * self;
	GtkClipboard* cb = NULL;
	GtkClipboard* _tmp0_;
	GtkClipboard* _tmp1_;
	SynapseMatchType _tmp2_;
	SynapseMatchType _tmp3_;
#line 32 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	self = (SynapseClipboardCopyAction*) base;
#line 33 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_tmp0_ = gtk_clipboard_get (GDK_NONE);
#line 33 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 33 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	cb = _tmp1_;
#line 34 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_tmp2_ = synapse_match_get_match_type (match);
#line 34 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_tmp3_ = _tmp2_;
#line 34 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	if (_tmp3_ == SYNAPSE_MATCH_TYPE_GENERIC_URI) {
#line 128 "ClipboardCopyAction.c"
		SynapseUriMatch* uri_match = NULL;
		SynapseUriMatch* _tmp4_;
		SynapseUriMatch* _tmp5_;
		GtkClipboard* _tmp6_;
		SynapseUriMatch* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 35 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp4_ = _g_object_ref0 (SYNAPSE_IS_URI_MATCH (match) ? ((SynapseUriMatch*) match) : NULL);
#line 35 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		uri_match = _tmp4_;
#line 36 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp5_ = uri_match;
#line 36 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		g_return_if_fail (_tmp5_ != NULL);
#line 46 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp6_ = cb;
#line 46 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp7_ = uri_match;
#line 46 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp8_ = synapse_uri_match_get_uri (_tmp7_);
#line 46 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp9_ = _tmp8_;
#line 46 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		gtk_clipboard_set_text (_tmp6_, _tmp9_, -1);
#line 34 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_g_object_unref0 (uri_match);
#line 156 "ClipboardCopyAction.c"
	} else {
		SynapseMatchType _tmp10_;
		SynapseMatchType _tmp11_;
#line 47 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp10_ = synapse_match_get_match_type (match);
#line 47 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp11_ = _tmp10_;
#line 47 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		if (_tmp11_ == SYNAPSE_MATCH_TYPE_TEXT) {
#line 166 "ClipboardCopyAction.c"
			SynapseTextMatch* text_match = NULL;
			SynapseTextMatch* _tmp12_;
			const gchar* _tmp13_ = NULL;
			SynapseTextMatch* _tmp14_;
			const gchar* content = NULL;
			GtkClipboard* _tmp20_;
			const gchar* _tmp21_;
#line 48 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			_tmp12_ = _g_object_ref0 (SYNAPSE_IS_TEXT_MATCH (match) ? ((SynapseTextMatch*) match) : NULL);
#line 48 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			text_match = _tmp12_;
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			_tmp14_ = text_match;
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			if (_tmp14_ != NULL) {
#line 182 "ClipboardCopyAction.c"
				SynapseTextMatch* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
				_tmp15_ = text_match;
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
				_tmp16_ = synapse_text_match_get_text (_tmp15_);
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
				_tmp17_ = _tmp16_;
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
				_tmp13_ = _tmp17_;
#line 194 "ClipboardCopyAction.c"
			} else {
				const gchar* _tmp18_;
				const gchar* _tmp19_;
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
				_tmp18_ = synapse_match_get_title (match);
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
				_tmp19_ = _tmp18_;
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
				_tmp13_ = _tmp19_;
#line 204 "ClipboardCopyAction.c"
			}
#line 49 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			content = _tmp13_;
#line 51 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			_tmp20_ = cb;
#line 51 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			_tmp21_ = content;
#line 51 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			gtk_clipboard_set_text (_tmp20_, _tmp21_, -1);
#line 47 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			_g_object_unref0 (text_match);
#line 216 "ClipboardCopyAction.c"
		}
	}
#line 32 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_g_object_unref0 (cb);
#line 221 "ClipboardCopyAction.c"
}

static gboolean
synapse_clipboard_copy_action_real_valid_for_match (SynapseBaseAction* base,
                                                    SynapseMatch* match)
{
	SynapseClipboardCopyAction * self;
	SynapseMatchType _tmp0_;
	SynapseMatchType _tmp1_;
	gboolean result;
#line 55 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	self = (SynapseClipboardCopyAction*) base;
#line 55 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	g_return_val_if_fail (match != NULL, FALSE);
#line 56 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_tmp0_ = synapse_match_get_match_type (match);
#line 56 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_tmp1_ = _tmp0_;
#line 56 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	switch (_tmp1_) {
#line 56 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		case SYNAPSE_MATCH_TYPE_GENERIC_URI:
#line 244 "ClipboardCopyAction.c"
		{
#line 58 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			result = TRUE;
#line 58 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			return result;
#line 250 "ClipboardCopyAction.c"
		}
#line 56 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		case SYNAPSE_MATCH_TYPE_TEXT:
#line 254 "ClipboardCopyAction.c"
		{
#line 60 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			result = TRUE;
#line 60 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			return result;
#line 260 "ClipboardCopyAction.c"
		}
		default:
		{
#line 62 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			result = FALSE;
#line 62 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
			return result;
#line 268 "ClipboardCopyAction.c"
		}
	}
}

static gint
synapse_clipboard_copy_action_real_get_relevancy_for_match (SynapseBaseAction* base,
                                                            SynapseMatch* match)
{
	SynapseClipboardCopyAction * self;
	SynapseTextMatch* text_match = NULL;
	gboolean _tmp0_ = FALSE;
	SynapseTextMatch* _tmp1_;
	gint _tmp5_;
	gint _tmp6_;
	gint result;
#line 66 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	self = (SynapseClipboardCopyAction*) base;
#line 66 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	g_return_val_if_fail (match != NULL, 0);
#line 67 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	text_match = SYNAPSE_IS_TEXT_MATCH (match) ? ((SynapseTextMatch*) match) : NULL;
#line 68 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_tmp1_ = text_match;
#line 68 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	if (_tmp1_ != NULL) {
#line 294 "ClipboardCopyAction.c"
		SynapseTextMatch* _tmp2_;
		SynapseTextOrigin _tmp3_;
		SynapseTextOrigin _tmp4_;
#line 68 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp2_ = text_match;
#line 68 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp3_ = synapse_text_match_get_text_origin (_tmp2_);
#line 68 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp4_ = _tmp3_;
#line 68 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp0_ = _tmp4_ == SYNAPSE_TEXT_ORIGIN_CLIPBOARD;
#line 306 "ClipboardCopyAction.c"
	} else {
#line 68 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		_tmp0_ = FALSE;
#line 310 "ClipboardCopyAction.c"
	}
#line 68 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	if (_tmp0_) {
#line 69 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		result = 0;
#line 69 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
		return result;
#line 318 "ClipboardCopyAction.c"
	}
#line 72 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_tmp5_ = synapse_base_action_get_default_relevancy ((SynapseBaseAction*) self);
#line 72 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	_tmp6_ = _tmp5_;
#line 72 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	result = _tmp6_;
#line 72 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	return result;
#line 328 "ClipboardCopyAction.c"
}

static void
synapse_clipboard_copy_action_class_init (SynapseClipboardCopyActionClass * klass,
                                          gpointer klass_data)
{
#line 23 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	synapse_clipboard_copy_action_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	((SynapseBaseActionClass *) klass)->do_execute = (void (*) (SynapseBaseAction*, SynapseMatch*, SynapseMatch*)) synapse_clipboard_copy_action_real_do_execute;
#line 23 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	((SynapseBaseActionClass *) klass)->valid_for_match = (gboolean (*) (SynapseBaseAction*, SynapseMatch*)) synapse_clipboard_copy_action_real_valid_for_match;
#line 23 "../src/synapse-core/Actions/ClipboardCopyAction.vala"
	((SynapseBaseActionClass *) klass)->get_relevancy_for_match = (gint (*) (SynapseBaseAction*, SynapseMatch*)) synapse_clipboard_copy_action_real_get_relevancy_for_match;
#line 343 "ClipboardCopyAction.c"
}

static void
synapse_clipboard_copy_action_instance_init (SynapseClipboardCopyAction * self,
                                             gpointer klass)
{
}

static GType
synapse_clipboard_copy_action_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseClipboardCopyActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_clipboard_copy_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseClipboardCopyAction), 0, (GInstanceInitFunc) synapse_clipboard_copy_action_instance_init, NULL };
	GType synapse_clipboard_copy_action_type_id;
	synapse_clipboard_copy_action_type_id = g_type_register_static (SYNAPSE_TYPE_BASE_ACTION, "SynapseClipboardCopyAction", &g_define_type_info, 0);
	return synapse_clipboard_copy_action_type_id;
}

GType
synapse_clipboard_copy_action_get_type (void)
{
	static volatile gsize synapse_clipboard_copy_action_type_id__once = 0;
	if (g_once_init_enter (&synapse_clipboard_copy_action_type_id__once)) {
		GType synapse_clipboard_copy_action_type_id;
		synapse_clipboard_copy_action_type_id = synapse_clipboard_copy_action_get_type_once ();
		g_once_init_leave (&synapse_clipboard_copy_action_type_id__once, synapse_clipboard_copy_action_type_id);
	}
	return synapse_clipboard_copy_action_type_id__once;
}

