/* ItemProvider.c generated by valac 0.56.7, the Vala compiler
 * generated from ItemProvider.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2017 elementary LLC.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*/

#include "slingshot.h"
#include <gio/gio.h>
#include <glib.h>

static gboolean synapse_item_provider_real_handles_query (SynapseItemProvider* self,
                                                   SynapseQuery* query);
static gboolean synapse_item_provider_real_handles_empty_query (SynapseItemProvider* self);
static GType synapse_item_provider_get_type_once (void);

void
synapse_item_provider_search (SynapseItemProvider* self,
                              SynapseQuery* query,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	SynapseItemProviderIface* _iface_;
#line 23 "../src/synapse-core/Interfaces/ItemProvider.vala"
	_iface_ = SYNAPSE_ITEM_PROVIDER_GET_INTERFACE (self);
#line 23 "../src/synapse-core/Interfaces/ItemProvider.vala"
	if (_iface_->search) {
#line 23 "../src/synapse-core/Interfaces/ItemProvider.vala"
		_iface_->search (self, query, _callback_, _user_data_);
#line 49 "ItemProvider.c"
	}
}

SynapseResultSet*
synapse_item_provider_search_finish (SynapseItemProvider* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	SynapseItemProviderIface* _iface_;
#line 23 "../src/synapse-core/Interfaces/ItemProvider.vala"
	_iface_ = SYNAPSE_ITEM_PROVIDER_GET_INTERFACE (self);
#line 23 "../src/synapse-core/Interfaces/ItemProvider.vala"
	if (_iface_->search_finish) {
#line 23 "../src/synapse-core/Interfaces/ItemProvider.vala"
		return _iface_->search_finish (self, _res_, error);
#line 65 "ItemProvider.c"
	}
#line 23 "../src/synapse-core/Interfaces/ItemProvider.vala"
	return NULL;
#line 69 "ItemProvider.c"
}

static gboolean
synapse_item_provider_real_handles_query (SynapseItemProvider* self,
                                          SynapseQuery* query)
{
	gboolean result;
#line 25 "../src/synapse-core/Interfaces/ItemProvider.vala"
	g_return_val_if_fail (query != NULL, FALSE);
#line 26 "../src/synapse-core/Interfaces/ItemProvider.vala"
	result = TRUE;
#line 26 "../src/synapse-core/Interfaces/ItemProvider.vala"
	return result;
#line 83 "ItemProvider.c"
}

gboolean
synapse_item_provider_handles_query (SynapseItemProvider* self,
                                     SynapseQuery* query)
{
	SynapseItemProviderIface* _iface_;
#line 25 "../src/synapse-core/Interfaces/ItemProvider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/synapse-core/Interfaces/ItemProvider.vala"
	_iface_ = SYNAPSE_ITEM_PROVIDER_GET_INTERFACE (self);
#line 25 "../src/synapse-core/Interfaces/ItemProvider.vala"
	if (_iface_->handles_query) {
#line 25 "../src/synapse-core/Interfaces/ItemProvider.vala"
		return _iface_->handles_query (self, query);
#line 99 "ItemProvider.c"
	}
#line 25 "../src/synapse-core/Interfaces/ItemProvider.vala"
	return FALSE;
#line 103 "ItemProvider.c"
}

static gboolean
synapse_item_provider_real_handles_empty_query (SynapseItemProvider* self)
{
	gboolean result;
#line 30 "../src/synapse-core/Interfaces/ItemProvider.vala"
	result = FALSE;
#line 30 "../src/synapse-core/Interfaces/ItemProvider.vala"
	return result;
#line 114 "ItemProvider.c"
}

gboolean
synapse_item_provider_handles_empty_query (SynapseItemProvider* self)
{
	SynapseItemProviderIface* _iface_;
#line 29 "../src/synapse-core/Interfaces/ItemProvider.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/synapse-core/Interfaces/ItemProvider.vala"
	_iface_ = SYNAPSE_ITEM_PROVIDER_GET_INTERFACE (self);
#line 29 "../src/synapse-core/Interfaces/ItemProvider.vala"
	if (_iface_->handles_empty_query) {
#line 29 "../src/synapse-core/Interfaces/ItemProvider.vala"
		return _iface_->handles_empty_query (self);
#line 129 "ItemProvider.c"
	}
#line 29 "../src/synapse-core/Interfaces/ItemProvider.vala"
	return FALSE;
#line 133 "ItemProvider.c"
}

static void
synapse_item_provider_default_init (SynapseItemProviderIface * iface,
                                    gpointer iface_data)
{
#line 23 "../src/synapse-core/Interfaces/ItemProvider.vala"
	iface->handles_query = synapse_item_provider_real_handles_query;
#line 23 "../src/synapse-core/Interfaces/ItemProvider.vala"
	iface->handles_empty_query = synapse_item_provider_real_handles_empty_query;
#line 144 "ItemProvider.c"
}

static GType
synapse_item_provider_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseItemProviderIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_item_provider_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType synapse_item_provider_type_id;
	synapse_item_provider_type_id = g_type_register_static (G_TYPE_INTERFACE, "SynapseItemProvider", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (synapse_item_provider_type_id, SYNAPSE_TYPE_ACTIVATABLE);
	return synapse_item_provider_type_id;
}

GType
synapse_item_provider_get_type (void)
{
	static volatile gsize synapse_item_provider_type_id__once = 0;
	if (g_once_init_enter (&synapse_item_provider_type_id__once)) {
		GType synapse_item_provider_type_id;
		synapse_item_provider_type_id = synapse_item_provider_get_type_once ();
		g_once_init_leave (&synapse_item_provider_type_id__once, synapse_item_provider_type_id);
	}
	return synapse_item_provider_type_id__once;
}

