/* desktop-file-service.c generated by valac 0.56.7, the Vala compiler
 * generated from desktop-file-service.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2017-2021 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include "slingshot.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>
#include <gio/gio.h>
#include <gee.h>

#define SYNAPSE_DESKTOP_FILE_SERVICE_DEFAULT_TIMEOUT_SECONDS 3

#define SYNAPSE_TYPE_DESKTOP_FILE_ERROR (synapse_desktop_file_error_get_type ())
enum  {
	SYNAPSE_DESKTOP_FILE_INFO_0_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY,
	SYNAPSE_DESKTOP_FILE_INFO_NUM_PROPERTIES
};
static GParamSpec* synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	SYNAPSE_DESKTOP_FILE_SERVICE_0_PROPERTY,
	SYNAPSE_DESKTOP_FILE_SERVICE_NUM_PROPERTIES
};
static GParamSpec* synapse_desktop_file_service_properties[SYNAPSE_DESKTOP_FILE_SERVICE_NUM_PROPERTIES];
#define _synapse_utils_async_once_unref0(var) ((var == NULL) ? NULL : (var = (synapse_utils_async_once_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _SynapseDesktopFileServiceInitializeData SynapseDesktopFileServiceInitializeData;
enum  {
	SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_STARTED_SIGNAL,
	SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_DONE_SIGNAL,
	SYNAPSE_DESKTOP_FILE_SERVICE_NUM_SIGNALS
};
static guint synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_NUM_SIGNALS] = {0};

typedef enum  {
	SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY
} SynapseDesktopFileError;
#define SYNAPSE_DESKTOP_FILE_ERROR synapse_desktop_file_error_quark ()

struct _SynapseDesktopFileInfoPrivate {
	gchar* _desktop_id;
	gchar* _name;
	gchar* _generic_name;
	gchar* _comment;
	gchar* _icon_name;
	gchar* _gettext_domain;
	gboolean _needs_terminal;
	gchar* _filename;
	gchar* _exec;
	gboolean _is_hidden;
	gboolean _is_valid;
	gchar* name_folded;
	SynapseDesktopFileInfoEnvironmentType _show_in;
};

struct _SynapseDesktopFileServicePrivate {
	SynapseUtilsAsyncOnce* init_once;
	GAppInfoMonitor* app_info_monitor;
	GeeList* non_hidden_desktop_files;
	GeeMap* exec_map;
	GeeMap* desktop_id_map;
	guint queued_update_id;
	GRegex* exec_regex;
};

struct _SynapseDesktopFileServiceInitializeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SynapseDesktopFileService* self;
	SynapseUtilsAsyncOnce* _tmp0_;
	gboolean is_locked;
	SynapseUtilsAsyncOnce* _tmp1_;
	GAppInfoMonitor* _tmp2_;
	GAppInfoMonitor* _tmp3_;
	SynapseUtilsAsyncOnce* _tmp4_;
};

static gint SynapseDesktopFileInfo_private_offset;
static gpointer synapse_desktop_file_info_parent_class = NULL;
static gint SynapseDesktopFileService_private_offset;
static gpointer synapse_desktop_file_service_parent_class = NULL;
static SynapseDesktopFileService* synapse_desktop_file_service_instance;
static SynapseDesktopFileService* synapse_desktop_file_service_instance = NULL;

VALA_EXTERN GQuark synapse_desktop_file_error_quark (void);
GType synapse_desktop_file_error_get_type (void) G_GNUC_CONST ;
static void synapse_desktop_file_info_init_from_desktop_app_info (SynapseDesktopFileInfo* self,
                                                           GDesktopAppInfo* app_info);
static SynapseDesktopFileInfoEnvironmentType synapse_desktop_file_info_parse_environments (SynapseDesktopFileInfo* self,
                                                                                    gchar** environments,
                                                                                    gint environments_length1);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void synapse_desktop_file_info_set_is_hidden (SynapseDesktopFileInfo* self,
                                              gboolean value);
static void synapse_desktop_file_info_set_is_valid (SynapseDesktopFileInfo* self,
                                             gboolean value);
static void synapse_desktop_file_info_finalize (GObject * obj);
static GType synapse_desktop_file_info_get_type_once (void);
static void _vala_synapse_desktop_file_info_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_synapse_desktop_file_info_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static SynapseDesktopFileService* synapse_desktop_file_service_new (void);
static SynapseDesktopFileService* synapse_desktop_file_service_construct (GType object_type);
static void synapse_desktop_file_service_initialize_data_free (gpointer _data);
static gboolean synapse_desktop_file_service_initialize_co (SynapseDesktopFileServiceInitializeData* _data_);
static void synapse_desktop_file_service_initialize_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void synapse_desktop_file_service_load_all_desktop_files (SynapseDesktopFileService* self);
static void synapse_desktop_file_service_queue_cache_update (SynapseDesktopFileService* self);
static void _synapse_desktop_file_service_queue_cache_update_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                                  gpointer self);
static gboolean __lambda6_ (SynapseDesktopFileService* self);
static gboolean ___lambda6__gsource_func (gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GObject * synapse_desktop_file_service_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static void synapse_desktop_file_service_finalize (GObject * obj);
static GType synapse_desktop_file_service_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* SYNAPSE_DESKTOP_FILE_INFO_SUPPORTED_GETTEXT_DOMAINS_KEYS[2] = {"X-Ubuntu-Gettext-Domain", "X-GNOME-Gettext-Domain"};

GQuark
synapse_desktop_file_error_quark (void)
{
#line 298 "../src/synapse-core/data-sink.vala"
	return g_quark_from_static_string ("synapse-desktop-file-error-quark");
#line 184 "desktop-file-service.c"
}

static GType
synapse_desktop_file_error_get_type_once (void)
{
	static const GEnumValue values[] = {{SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY, "SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY", "uninteresting-entry"}, {0, NULL, NULL}};
	GType synapse_desktop_file_error_type_id;
	synapse_desktop_file_error_type_id = g_enum_register_static ("SynapseDesktopFileError", values);
	return synapse_desktop_file_error_type_id;
}

GType
synapse_desktop_file_error_get_type (void)
{
	static volatile gsize synapse_desktop_file_error_type_id__once = 0;
	if (g_once_init_enter (&synapse_desktop_file_error_type_id__once)) {
		GType synapse_desktop_file_error_type_id;
		synapse_desktop_file_error_type_id = synapse_desktop_file_error_get_type_once ();
		g_once_init_leave (&synapse_desktop_file_error_type_id__once, synapse_desktop_file_error_type_id);
	}
	return synapse_desktop_file_error_type_id__once;
}

static inline gpointer
synapse_desktop_file_info_get_instance_private (SynapseDesktopFileInfo* self)
{
	return G_STRUCT_MEMBER_P (self, SynapseDesktopFileInfo_private_offset);
}

static GType
synapse_desktop_file_info_environment_type_get_type_once (void)
{
	static const GFlagsValue values[] = {{SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_GNOME, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_GNOME", "gnome"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_KDE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_KDE", "kde"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXDE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXDE", "lxde"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXQT, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXQT", "lxqt"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_MATE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_MATE", "mate"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_RAZOR, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_RAZOR", "razor"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ROX, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ROX", "rox"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_TDE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_TDE", "tde"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_UNITY, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_UNITY", "unity"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_XFCE, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_XFCE", "xfce"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_PANTHEON, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_PANTHEON", "pantheon"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_OLD, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_OLD", "old"}, {SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL, "SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL", "all"}, {0, NULL, NULL}};
	GType synapse_desktop_file_info_environment_type_type_id;
	synapse_desktop_file_info_environment_type_type_id = g_flags_register_static ("SynapseDesktopFileInfoEnvironmentType", values);
	return synapse_desktop_file_info_environment_type_type_id;
}

GType
synapse_desktop_file_info_environment_type_get_type (void)
{
	static volatile gsize synapse_desktop_file_info_environment_type_type_id__once = 0;
	if (g_once_init_enter (&synapse_desktop_file_info_environment_type_type_id__once)) {
		GType synapse_desktop_file_info_environment_type_type_id;
		synapse_desktop_file_info_environment_type_type_id = synapse_desktop_file_info_environment_type_get_type_once ();
		g_once_init_leave (&synapse_desktop_file_info_environment_type_type_id__once, synapse_desktop_file_info_environment_type_type_id);
	}
	return synapse_desktop_file_info_environment_type_type_id__once;
}

const gchar*
synapse_desktop_file_info_get_name_folded (SynapseDesktopFileInfo* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	const gchar* result;
#line 65 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->name_folded;
#line 66 "../src/synapse-core/desktop-file-service.vala"
	if (_tmp0_ == NULL) {
#line 247 "desktop-file-service.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 67 "../src/synapse-core/desktop-file-service.vala"
		_tmp1_ = self->priv->_name;
#line 67 "../src/synapse-core/desktop-file-service.vala"
		_tmp2_ = g_utf8_casefold (_tmp1_, (gssize) -1);
#line 67 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->name_folded);
#line 67 "../src/synapse-core/desktop-file-service.vala"
		self->priv->name_folded = _tmp2_;
#line 258 "desktop-file-service.c"
	}
#line 70 "../src/synapse-core/desktop-file-service.vala"
	_tmp3_ = self->priv->name_folded;
#line 70 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp3_;
#line 70 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 266 "desktop-file-service.c"
}

SynapseDesktopFileInfo*
synapse_desktop_file_info_construct_for_desktop_app_info (GType object_type,
                                                          GDesktopAppInfo* app_info)
{
	SynapseDesktopFileInfo * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 77 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (app_info != NULL, NULL);
#line 78 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = g_app_info_get_id ((GAppInfo*) app_info);
#line 78 "../src/synapse-core/desktop-file-service.vala"
	_tmp1_ = g_desktop_app_info_get_filename (app_info);
#line 78 "../src/synapse-core/desktop-file-service.vala"
	_tmp2_ = _tmp1_;
#line 78 "../src/synapse-core/desktop-file-service.vala"
	self = (SynapseDesktopFileInfo*) g_object_new (object_type, "desktop-id", _tmp0_, "filename", _tmp2_, NULL);
#line 80 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_info_init_from_desktop_app_info (self, app_info);
#line 77 "../src/synapse-core/desktop-file-service.vala"
	return self;
#line 291 "desktop-file-service.c"
}

SynapseDesktopFileInfo*
synapse_desktop_file_info_new_for_desktop_app_info (GDesktopAppInfo* app_info)
{
#line 77 "../src/synapse-core/desktop-file-service.vala"
	return synapse_desktop_file_info_construct_for_desktop_app_info (SYNAPSE_TYPE_DESKTOP_FILE_INFO, app_info);
#line 299 "desktop-file-service.c"
}

static SynapseDesktopFileInfoEnvironmentType
synapse_desktop_file_info_parse_environments (SynapseDesktopFileInfo* self,
                                              gchar** environments,
                                              gint environments_length1)
{
	SynapseDesktopFileInfoEnvironmentType _result_ = 0U;
	SynapseDesktopFileInfoEnvironmentType result;
#line 83 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 84 "../src/synapse-core/desktop-file-service.vala"
	_result_ = 0;
#line 313 "desktop-file-service.c"
	{
		gchar** env_collection = NULL;
		gint env_collection_length1 = 0;
		gint _env_collection_size_ = 0;
		gint env_it = 0;
#line 85 "../src/synapse-core/desktop-file-service.vala"
		env_collection = environments;
#line 85 "../src/synapse-core/desktop-file-service.vala"
		env_collection_length1 = environments_length1;
#line 85 "../src/synapse-core/desktop-file-service.vala"
		for (env_it = 0; env_it < env_collection_length1; env_it = env_it + 1) {
#line 325 "desktop-file-service.c"
			const gchar* env = NULL;
#line 85 "../src/synapse-core/desktop-file-service.vala"
			env = env_collection[env_it];
#line 329 "desktop-file-service.c"
			{
				gchar* env_up = NULL;
				const gchar* _tmp0_;
				gchar* _tmp1_;
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				GQuark _tmp5_ = 0U;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label0 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label1 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label2 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label3 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label4 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label5 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label6 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label7 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label8 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label9 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label10 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label11 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label12 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label13 = 0;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				static GQuark _tmp4_label14 = 0;
#line 86 "../src/synapse-core/desktop-file-service.vala"
				_tmp0_ = env;
#line 86 "../src/synapse-core/desktop-file-service.vala"
				_tmp1_ = g_utf8_strup (_tmp0_, (gssize) -1);
#line 86 "../src/synapse-core/desktop-file-service.vala"
				env_up = _tmp1_;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				_tmp2_ = env_up;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				_tmp3_ = _tmp2_;
#line 87 "../src/synapse-core/desktop-file-service.vala"
				_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 87 "../src/synapse-core/desktop-file-service.vala"
				if (((_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("GNOME")))) || (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("X-CINNAMON"))))) || (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("UBUNTU"))))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 383 "desktop-file-service.c"
						default:
						{
#line 91 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_GNOME;
#line 92 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 390 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("PANTHEON")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 396 "desktop-file-service.c"
						default:
						{
#line 94 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_PANTHEON;
#line 95 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 403 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("KDE")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 409 "desktop-file-service.c"
						default:
						{
#line 97 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_KDE;
#line 98 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 416 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("LXDE")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 422 "desktop-file-service.c"
						default:
						{
#line 100 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXDE;
#line 101 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 429 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label6) ? _tmp4_label6 : (_tmp4_label6 = g_quark_from_static_string ("LXQT")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 435 "desktop-file-service.c"
						default:
						{
#line 103 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_LXQT;
#line 104 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 442 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label7) ? _tmp4_label7 : (_tmp4_label7 = g_quark_from_static_string ("MATE")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 448 "desktop-file-service.c"
						default:
						{
#line 106 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_MATE;
#line 107 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 455 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label8) ? _tmp4_label8 : (_tmp4_label8 = g_quark_from_static_string ("RAZOR")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 461 "desktop-file-service.c"
						default:
						{
#line 109 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_RAZOR;
#line 110 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 468 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label9) ? _tmp4_label9 : (_tmp4_label9 = g_quark_from_static_string ("ROX")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 474 "desktop-file-service.c"
						default:
						{
#line 111 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ROX;
#line 111 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 481 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label10) ? _tmp4_label10 : (_tmp4_label10 = g_quark_from_static_string ("TDE")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 487 "desktop-file-service.c"
						default:
						{
#line 112 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_TDE;
#line 112 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 494 "desktop-file-service.c"
						}
					}
				} else if ((_tmp5_ == ((0 != _tmp4_label11) ? _tmp4_label11 : (_tmp4_label11 = g_quark_from_static_string ("UNITY")))) || (_tmp5_ == ((0 != _tmp4_label12) ? _tmp4_label12 : (_tmp4_label12 = g_quark_from_static_string ("UNITY7"))))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 500 "desktop-file-service.c"
						default:
						{
#line 115 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_UNITY;
#line 116 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 507 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label13) ? _tmp4_label13 : (_tmp4_label13 = g_quark_from_static_string ("XFCE")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 513 "desktop-file-service.c"
						default:
						{
#line 117 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_XFCE;
#line 117 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 520 "desktop-file-service.c"
						}
					}
				} else if (_tmp5_ == ((0 != _tmp4_label14) ? _tmp4_label14 : (_tmp4_label14 = g_quark_from_static_string ("OLD")))) {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 526 "desktop-file-service.c"
						default:
						{
#line 118 "../src/synapse-core/desktop-file-service.vala"
							_result_ |= SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_OLD;
#line 118 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 533 "desktop-file-service.c"
						}
					}
				} else {
#line 87 "../src/synapse-core/desktop-file-service.vala"
					switch (0) {
#line 539 "desktop-file-service.c"
						default:
						{
							const gchar* _tmp6_;
#line 119 "../src/synapse-core/desktop-file-service.vala"
							_tmp6_ = env;
#line 119 "../src/synapse-core/desktop-file-service.vala"
							g_warning ("desktop-file-service.vala:119: %s is not understood", _tmp6_);
#line 119 "../src/synapse-core/desktop-file-service.vala"
							break;
#line 549 "desktop-file-service.c"
						}
					}
				}
#line 85 "../src/synapse-core/desktop-file-service.vala"
				_g_free0 (env_up);
#line 555 "desktop-file-service.c"
			}
		}
	}
#line 122 "../src/synapse-core/desktop-file-service.vala"
	result = _result_;
#line 122 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 563 "desktop-file-service.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 133 "../src/synapse-core/desktop-file-service.vala"
	for (i = 0; i < stack_length; i++) {
#line 133 "../src/synapse-core/desktop-file-service.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 133 "../src/synapse-core/desktop-file-service.vala"
			return TRUE;
#line 578 "desktop-file-service.c"
		}
	}
#line 133 "../src/synapse-core/desktop-file-service.vala"
	return FALSE;
#line 583 "desktop-file-service.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 156 "../src/synapse-core/desktop-file-service.vala"
	return self ? g_object_ref (self) : NULL;
#line 591 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_init_from_desktop_app_info (SynapseDesktopFileInfo* self,
                                                      GDesktopAppInfo* app_info)
{
	GError* _inner_error0_ = NULL;
#line 125 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (app_info != NULL);
#line 603 "desktop-file-service.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		gboolean _tmp2_;
		const gchar* _tmp12_;
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp22_ = NULL;
		const gchar* _tmp23_;
		GIcon* _tmp24_ = NULL;
		GIcon* _tmp25_;
		GIcon* _tmp26_;
		GIcon* icon = NULL;
		GIcon* _tmp28_;
		GIcon* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 127 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_desktop_app_info_get_string (app_info, G_KEY_FILE_DESKTOP_KEY_TYPE);
#line 127 "../src/synapse-core/desktop-file-service.vala"
		_tmp1_ = _tmp0_;
#line 127 "../src/synapse-core/desktop-file-service.vala"
		_tmp2_ = g_strcmp0 (_tmp1_, G_KEY_FILE_DESKTOP_TYPE_APPLICATION) != 0;
#line 127 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (_tmp1_);
#line 127 "../src/synapse-core/desktop-file-service.vala"
		if (_tmp2_) {
#line 633 "desktop-file-service.c"
			GError* _tmp3_;
#line 128 "../src/synapse-core/desktop-file-service.vala"
			_tmp3_ = g_error_new_literal (SYNAPSE_DESKTOP_FILE_ERROR, SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY, "Not Application-type desktop entry");
#line 128 "../src/synapse-core/desktop-file-service.vala"
			_inner_error0_ = _tmp3_;
#line 639 "desktop-file-service.c"
			goto __catch0_g_error;
		}
#line 131 "../src/synapse-core/desktop-file-service.vala"
		if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_CATEGORIES)) {
#line 644 "desktop-file-service.c"
			gchar** categories = NULL;
			gsize _tmp4_ = 0;
			gchar** _tmp5_;
			gint categories_length1;
			gint _categories_size_;
			gchar** _tmp6_;
			gint _tmp6__length1;
#line 132 "../src/synapse-core/desktop-file-service.vala"
			_tmp5_ = g_desktop_app_info_get_string_list (app_info, G_KEY_FILE_DESKTOP_KEY_CATEGORIES, &_tmp4_);
#line 132 "../src/synapse-core/desktop-file-service.vala"
			categories = _tmp5_;
#line 132 "../src/synapse-core/desktop-file-service.vala"
			categories_length1 = _tmp4_;
#line 132 "../src/synapse-core/desktop-file-service.vala"
			_categories_size_ = categories_length1;
#line 133 "../src/synapse-core/desktop-file-service.vala"
			_tmp6_ = categories;
#line 133 "../src/synapse-core/desktop-file-service.vala"
			_tmp6__length1 = categories_length1;
#line 133 "../src/synapse-core/desktop-file-service.vala"
			if (_vala_string_array_contains (_tmp6_, _tmp6__length1, "Screensaver")) {
#line 666 "desktop-file-service.c"
				GError* _tmp7_;
#line 134 "../src/synapse-core/desktop-file-service.vala"
				_tmp7_ = g_error_new_literal (SYNAPSE_DESKTOP_FILE_ERROR, SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY, "Screensaver desktop entry");
#line 134 "../src/synapse-core/desktop-file-service.vala"
				_inner_error0_ = _tmp7_;
#line 134 "../src/synapse-core/desktop-file-service.vala"
				categories = (_vala_array_free (categories, categories_length1, (GDestroyNotify) g_free), NULL);
#line 674 "desktop-file-service.c"
				goto __catch0_g_error;
			}
#line 131 "../src/synapse-core/desktop-file-service.vala"
			categories = (_vala_array_free (categories, categories_length1, (GDestroyNotify) g_free), NULL);
#line 679 "desktop-file-service.c"
		}
		{
			const gchar** domain_key_collection = NULL;
			gint domain_key_collection_length1 = 0;
			gint _domain_key_collection_size_ = 0;
			gint domain_key_it = 0;
#line 138 "../src/synapse-core/desktop-file-service.vala"
			domain_key_collection = SYNAPSE_DESKTOP_FILE_INFO_SUPPORTED_GETTEXT_DOMAINS_KEYS;
#line 138 "../src/synapse-core/desktop-file-service.vala"
			domain_key_collection_length1 = G_N_ELEMENTS (SYNAPSE_DESKTOP_FILE_INFO_SUPPORTED_GETTEXT_DOMAINS_KEYS);
#line 138 "../src/synapse-core/desktop-file-service.vala"
			for (domain_key_it = 0; domain_key_it < domain_key_collection_length1; domain_key_it = domain_key_it + 1) {
#line 692 "desktop-file-service.c"
				const gchar* domain_key = NULL;
#line 138 "../src/synapse-core/desktop-file-service.vala"
				domain_key = domain_key_collection[domain_key_it];
#line 696 "desktop-file-service.c"
				{
					const gchar* _tmp8_;
#line 139 "../src/synapse-core/desktop-file-service.vala"
					_tmp8_ = domain_key;
#line 139 "../src/synapse-core/desktop-file-service.vala"
					if (g_desktop_app_info_has_key (app_info, _tmp8_)) {
#line 703 "desktop-file-service.c"
						const gchar* _tmp9_;
						gchar* _tmp10_;
						gchar* _tmp11_;
#line 140 "../src/synapse-core/desktop-file-service.vala"
						_tmp9_ = domain_key;
#line 140 "../src/synapse-core/desktop-file-service.vala"
						_tmp10_ = g_desktop_app_info_get_string (app_info, _tmp9_);
#line 140 "../src/synapse-core/desktop-file-service.vala"
						_tmp11_ = _tmp10_;
#line 140 "../src/synapse-core/desktop-file-service.vala"
						synapse_desktop_file_info_set_gettext_domain (self, _tmp11_);
#line 140 "../src/synapse-core/desktop-file-service.vala"
						_g_free0 (_tmp11_);
#line 141 "../src/synapse-core/desktop-file-service.vala"
						break;
#line 719 "desktop-file-service.c"
					}
				}
			}
		}
#line 145 "../src/synapse-core/desktop-file-service.vala"
		_tmp12_ = g_app_info_get_name ((GAppInfo*) app_info);
#line 145 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_name (self, _tmp12_);
#line 146 "../src/synapse-core/desktop-file-service.vala"
		_tmp14_ = g_desktop_app_info_get_generic_name (app_info);
#line 146 "../src/synapse-core/desktop-file-service.vala"
		_tmp13_ = _tmp14_;
#line 146 "../src/synapse-core/desktop-file-service.vala"
		if (_tmp13_ == NULL) {
#line 146 "../src/synapse-core/desktop-file-service.vala"
			_tmp13_ = "";
#line 736 "desktop-file-service.c"
		}
#line 146 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_generic_name (self, _tmp13_);
#line 147 "../src/synapse-core/desktop-file-service.vala"
		_tmp15_ = g_app_info_get_commandline ((GAppInfo*) app_info);
#line 147 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_exec (self, _tmp15_);
#line 149 "../src/synapse-core/desktop-file-service.vala"
		_tmp16_ = self->priv->_exec;
#line 149 "../src/synapse-core/desktop-file-service.vala"
		if (_tmp16_ == NULL) {
#line 748 "desktop-file-service.c"
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			GError* _tmp20_;
			GError* _tmp21_;
#line 150 "../src/synapse-core/desktop-file-service.vala"
			_tmp17_ = self->priv->_name;
#line 150 "../src/synapse-core/desktop-file-service.vala"
			_tmp18_ = g_strdup_printf ("Unable to get exec for %s", _tmp17_);
#line 150 "../src/synapse-core/desktop-file-service.vala"
			_tmp19_ = _tmp18_;
#line 150 "../src/synapse-core/desktop-file-service.vala"
			_tmp20_ = g_error_new_literal (SYNAPSE_DESKTOP_FILE_ERROR, SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY, _tmp19_);
#line 150 "../src/synapse-core/desktop-file-service.vala"
			_tmp21_ = _tmp20_;
#line 150 "../src/synapse-core/desktop-file-service.vala"
			_g_free0 (_tmp19_);
#line 150 "../src/synapse-core/desktop-file-service.vala"
			_inner_error0_ = _tmp21_;
#line 768 "desktop-file-service.c"
			goto __catch0_g_error;
		}
#line 153 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_is_hidden (self, !g_app_info_should_show ((GAppInfo*) app_info));
#line 154 "../src/synapse-core/desktop-file-service.vala"
		_tmp23_ = g_app_info_get_description ((GAppInfo*) app_info);
#line 154 "../src/synapse-core/desktop-file-service.vala"
		_tmp22_ = _tmp23_;
#line 154 "../src/synapse-core/desktop-file-service.vala"
		if (_tmp22_ == NULL) {
#line 154 "../src/synapse-core/desktop-file-service.vala"
			_tmp22_ = "";
#line 781 "desktop-file-service.c"
		}
#line 154 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_comment (self, _tmp22_);
#line 156 "../src/synapse-core/desktop-file-service.vala"
		_tmp25_ = g_app_info_get_icon ((GAppInfo*) app_info);
#line 156 "../src/synapse-core/desktop-file-service.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 156 "../src/synapse-core/desktop-file-service.vala"
		_tmp24_ = _tmp26_;
#line 156 "../src/synapse-core/desktop-file-service.vala"
		if (_tmp24_ == NULL) {
#line 793 "desktop-file-service.c"
			GThemedIcon* _tmp27_;
#line 157 "../src/synapse-core/desktop-file-service.vala"
			_tmp27_ = (GThemedIcon*) g_themed_icon_new ("application-default-icon");
#line 157 "../src/synapse-core/desktop-file-service.vala"
			_g_object_unref0 (_tmp24_);
#line 157 "../src/synapse-core/desktop-file-service.vala"
			_tmp24_ = (GIcon*) _tmp27_;
#line 801 "desktop-file-service.c"
		}
#line 156 "../src/synapse-core/desktop-file-service.vala"
		_tmp28_ = _tmp24_;
#line 156 "../src/synapse-core/desktop-file-service.vala"
		_tmp24_ = NULL;
#line 156 "../src/synapse-core/desktop-file-service.vala"
		icon = _tmp28_;
#line 158 "../src/synapse-core/desktop-file-service.vala"
		_tmp29_ = icon;
#line 158 "../src/synapse-core/desktop-file-service.vala"
		_tmp30_ = g_icon_to_string (_tmp29_);
#line 158 "../src/synapse-core/desktop-file-service.vala"
		_tmp31_ = _tmp30_;
#line 158 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_icon_name (self, _tmp31_);
#line 158 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (_tmp31_);
#line 160 "../src/synapse-core/desktop-file-service.vala"
		if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_TERMINAL)) {
#line 161 "../src/synapse-core/desktop-file-service.vala"
			synapse_desktop_file_info_set_needs_terminal (self, g_desktop_app_info_get_boolean (app_info, G_KEY_FILE_DESKTOP_KEY_TERMINAL));
#line 823 "desktop-file-service.c"
		}
#line 163 "../src/synapse-core/desktop-file-service.vala"
		if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN)) {
#line 827 "desktop-file-service.c"
			gsize _tmp32_ = 0;
			gchar** _tmp33_;
			gchar** _tmp34_;
			gint _tmp34__length1;
#line 164 "../src/synapse-core/desktop-file-service.vala"
			_tmp33_ = g_desktop_app_info_get_string_list (app_info, G_KEY_FILE_DESKTOP_KEY_ONLY_SHOW_IN, &_tmp32_);
#line 164 "../src/synapse-core/desktop-file-service.vala"
			_tmp34_ = _tmp33_;
#line 164 "../src/synapse-core/desktop-file-service.vala"
			_tmp34__length1 = _tmp32_;
#line 164 "../src/synapse-core/desktop-file-service.vala"
			synapse_desktop_file_info_set_show_in (self, synapse_desktop_file_info_parse_environments (self, _tmp34_, (gint) _tmp32_));
#line 164 "../src/synapse-core/desktop-file-service.vala"
			_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) g_free), NULL);
#line 842 "desktop-file-service.c"
		} else {
#line 165 "../src/synapse-core/desktop-file-service.vala"
			if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN)) {
#line 846 "desktop-file-service.c"
				SynapseDesktopFileInfoEnvironmentType not_show = 0U;
				gsize _tmp35_ = 0;
				gchar** _tmp36_;
				gchar** _tmp37_;
				gint _tmp37__length1;
				SynapseDesktopFileInfoEnvironmentType _tmp38_;
#line 166 "../src/synapse-core/desktop-file-service.vala"
				_tmp36_ = g_desktop_app_info_get_string_list (app_info, G_KEY_FILE_DESKTOP_KEY_NOT_SHOW_IN, &_tmp35_);
#line 166 "../src/synapse-core/desktop-file-service.vala"
				_tmp37_ = _tmp36_;
#line 166 "../src/synapse-core/desktop-file-service.vala"
				_tmp37__length1 = _tmp35_;
#line 166 "../src/synapse-core/desktop-file-service.vala"
				_tmp38_ = synapse_desktop_file_info_parse_environments (self, _tmp37_, (gint) _tmp35_);
#line 166 "../src/synapse-core/desktop-file-service.vala"
				_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
#line 166 "../src/synapse-core/desktop-file-service.vala"
				not_show = _tmp38_;
#line 167 "../src/synapse-core/desktop-file-service.vala"
				synapse_desktop_file_info_set_show_in (self, SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL ^ not_show);
#line 867 "desktop-file-service.c"
			}
		}
#line 126 "../src/synapse-core/desktop-file-service.vala"
		_g_object_unref0 (icon);
#line 126 "../src/synapse-core/desktop-file-service.vala"
		_g_object_unref0 (_tmp24_);
#line 874 "desktop-file-service.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* name = NULL;
		gchar* _tmp39_;
		GError* _tmp41_;
#line 126 "../src/synapse-core/desktop-file-service.vala"
		err = _inner_error0_;
#line 126 "../src/synapse-core/desktop-file-service.vala"
		_inner_error0_ = NULL;
#line 170 "../src/synapse-core/desktop-file-service.vala"
		_tmp39_ = g_strdup ("Unidentified");
#line 170 "../src/synapse-core/desktop-file-service.vala"
		name = _tmp39_;
#line 172 "../src/synapse-core/desktop-file-service.vala"
		if (g_desktop_app_info_has_key (app_info, G_KEY_FILE_DESKTOP_KEY_NAME)) {
#line 893 "desktop-file-service.c"
			gchar* _tmp40_;
#line 173 "../src/synapse-core/desktop-file-service.vala"
			_tmp40_ = g_desktop_app_info_get_string (app_info, G_KEY_FILE_DESKTOP_KEY_NAME);
#line 173 "../src/synapse-core/desktop-file-service.vala"
			_g_free0 (name);
#line 173 "../src/synapse-core/desktop-file-service.vala"
			name = _tmp40_;
#line 901 "desktop-file-service.c"
		}
#line 176 "../src/synapse-core/desktop-file-service.vala"
		_tmp41_ = err;
#line 176 "../src/synapse-core/desktop-file-service.vala"
		if (g_error_matches (_tmp41_, SYNAPSE_DESKTOP_FILE_ERROR, SYNAPSE_DESKTOP_FILE_ERROR_UNINTERESTING_ENTRY)) {
#line 907 "desktop-file-service.c"
			const gchar* _tmp42_;
			GError* _tmp43_;
			const gchar* _tmp44_;
#line 177 "../src/synapse-core/desktop-file-service.vala"
			_tmp42_ = name;
#line 177 "../src/synapse-core/desktop-file-service.vala"
			_tmp43_ = err;
#line 177 "../src/synapse-core/desktop-file-service.vala"
			_tmp44_ = _tmp43_->message;
#line 177 "../src/synapse-core/desktop-file-service.vala"
			g_debug ("desktop-file-service.vala:177: Ignoring DesktopFileInfo %s - %s", _tmp42_, _tmp44_);
#line 919 "desktop-file-service.c"
		} else {
			GError* _tmp45_;
			const gchar* _tmp46_;
#line 179 "../src/synapse-core/desktop-file-service.vala"
			_tmp45_ = err;
#line 179 "../src/synapse-core/desktop-file-service.vala"
			_tmp46_ = _tmp45_->message;
#line 179 "../src/synapse-core/desktop-file-service.vala"
			g_warning ("desktop-file-service.vala:179: Error initializing DesktopFileInfo from" \
" DesktopAppInfo - %s", _tmp46_);
#line 929 "desktop-file-service.c"
		}
#line 185 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_is_valid (self, FALSE);
#line 126 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (name);
#line 126 "../src/synapse-core/desktop-file-service.vala"
		_g_error_free0 (err);
#line 937 "desktop-file-service.c"
	}
	__finally0:
#line 126 "../src/synapse-core/desktop-file-service.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 126 "../src/synapse-core/desktop-file-service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 126 "../src/synapse-core/desktop-file-service.vala"
		g_clear_error (&_inner_error0_);
#line 126 "../src/synapse-core/desktop-file-service.vala"
		return;
#line 948 "desktop-file-service.c"
	}
}

SynapseDesktopFileInfo*
synapse_desktop_file_info_construct (GType object_type)
{
	SynapseDesktopFileInfo * self = NULL;
#line 28 "../src/synapse-core/desktop-file-service.vala"
	self = (SynapseDesktopFileInfo*) g_object_new (object_type, NULL);
#line 28 "../src/synapse-core/desktop-file-service.vala"
	return self;
#line 960 "desktop-file-service.c"
}

SynapseDesktopFileInfo*
synapse_desktop_file_info_new (void)
{
#line 28 "../src/synapse-core/desktop-file-service.vala"
	return synapse_desktop_file_info_construct (SYNAPSE_TYPE_DESKTOP_FILE_INFO);
#line 968 "desktop-file-service.c"
}

const gchar*
synapse_desktop_file_info_get_desktop_id (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_desktop_id;
#line 49 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 49 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 984 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_desktop_id (SynapseDesktopFileInfo* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 49 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_desktop_id (self);
#line 49 "../src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 998 "desktop-file-service.c"
		gchar* _tmp0_;
#line 49 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_desktop_id);
#line 49 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_desktop_id = _tmp0_;
#line 49 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY]);
#line 1008 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_name (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_name;
#line 50 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 50 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1025 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_name (SynapseDesktopFileInfo* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 50 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_name (self);
#line 50 "../src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1039 "desktop-file-service.c"
		gchar* _tmp0_;
#line 50 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_name);
#line 50 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_name = _tmp0_;
#line 50 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY]);
#line 1049 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_generic_name (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 51 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_generic_name;
#line 51 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 51 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1066 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_generic_name (SynapseDesktopFileInfo* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 51 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_generic_name (self);
#line 51 "../src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1080 "desktop-file-service.c"
		gchar* _tmp0_;
#line 51 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 51 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_generic_name);
#line 51 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_generic_name = _tmp0_;
#line 51 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY]);
#line 1090 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_comment (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_comment;
#line 52 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 52 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1107 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_comment (SynapseDesktopFileInfo* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 52 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_comment (self);
#line 52 "../src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1121 "desktop-file-service.c"
		gchar* _tmp0_;
#line 52 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_comment);
#line 52 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_comment = _tmp0_;
#line 52 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY]);
#line 1131 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_icon_name (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 53 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_icon_name;
#line 53 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 53 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1148 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_icon_name (SynapseDesktopFileInfo* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 53 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_icon_name (self);
#line 53 "../src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1162 "desktop-file-service.c"
		gchar* _tmp0_;
#line 53 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 53 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_icon_name);
#line 53 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_icon_name = _tmp0_;
#line 53 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY]);
#line 1172 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_gettext_domain (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_gettext_domain;
#line 54 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 54 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1189 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_gettext_domain (SynapseDesktopFileInfo* self,
                                              const gchar* value)
{
	gchar* old_value;
#line 54 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_gettext_domain (self);
#line 54 "../src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1203 "desktop-file-service.c"
		gchar* _tmp0_;
#line 54 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 54 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_gettext_domain);
#line 54 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_gettext_domain = _tmp0_;
#line 54 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY]);
#line 1213 "desktop-file-service.c"
	}
}

gboolean
synapse_desktop_file_info_get_needs_terminal (SynapseDesktopFileInfo* self)
{
	gboolean result;
#line 56 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../src/synapse-core/desktop-file-service.vala"
	result = self->priv->_needs_terminal;
#line 56 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1227 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_needs_terminal (SynapseDesktopFileInfo* self,
                                              gboolean value)
{
	gboolean old_value;
#line 56 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_needs_terminal (self);
#line 56 "../src/synapse-core/desktop-file-service.vala"
	if (old_value != value) {
#line 56 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_needs_terminal = value;
#line 56 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY]);
#line 1245 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_filename (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 57 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_filename;
#line 57 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 57 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1262 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_filename (SynapseDesktopFileInfo* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 57 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_filename (self);
#line 57 "../src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1276 "desktop-file-service.c"
		gchar* _tmp0_;
#line 57 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 57 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_filename);
#line 57 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_filename = _tmp0_;
#line 57 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY]);
#line 1286 "desktop-file-service.c"
	}
}

const gchar*
synapse_desktop_file_info_get_exec (SynapseDesktopFileInfo* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 59 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->_exec;
#line 59 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp0_;
#line 59 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1303 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_exec (SynapseDesktopFileInfo* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 59 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_exec (self);
#line 59 "../src/synapse-core/desktop-file-service.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1317 "desktop-file-service.c"
		gchar* _tmp0_;
#line 59 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = g_strdup (value);
#line 59 "../src/synapse-core/desktop-file-service.vala"
		_g_free0 (self->priv->_exec);
#line 59 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_exec = _tmp0_;
#line 59 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY]);
#line 1327 "desktop-file-service.c"
	}
}

gboolean
synapse_desktop_file_info_get_is_hidden (SynapseDesktopFileInfo* self)
{
	gboolean result;
#line 61 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/synapse-core/desktop-file-service.vala"
	result = self->priv->_is_hidden;
#line 61 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1341 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_set_is_hidden (SynapseDesktopFileInfo* self,
                                         gboolean value)
{
	gboolean old_value;
#line 61 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_is_hidden (self);
#line 61 "../src/synapse-core/desktop-file-service.vala"
	if (old_value != value) {
#line 61 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_is_hidden = value;
#line 61 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY]);
#line 1359 "desktop-file-service.c"
	}
}

gboolean
synapse_desktop_file_info_get_is_valid (SynapseDesktopFileInfo* self)
{
	gboolean result;
#line 62 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../src/synapse-core/desktop-file-service.vala"
	result = self->priv->_is_valid;
#line 62 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1373 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_set_is_valid (SynapseDesktopFileInfo* self,
                                        gboolean value)
{
	gboolean old_value;
#line 62 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_is_valid (self);
#line 62 "../src/synapse-core/desktop-file-service.vala"
	if (old_value != value) {
#line 62 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_is_valid = value;
#line 62 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY]);
#line 1391 "desktop-file-service.c"
	}
}

SynapseDesktopFileInfoEnvironmentType
synapse_desktop_file_info_get_show_in (SynapseDesktopFileInfo* self)
{
	SynapseDesktopFileInfoEnvironmentType result;
#line 73 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 73 "../src/synapse-core/desktop-file-service.vala"
	result = self->priv->_show_in;
#line 73 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1405 "desktop-file-service.c"
}

void
synapse_desktop_file_info_set_show_in (SynapseDesktopFileInfo* self,
                                       SynapseDesktopFileInfoEnvironmentType value)
{
	SynapseDesktopFileInfoEnvironmentType old_value;
#line 73 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/synapse-core/desktop-file-service.vala"
	old_value = synapse_desktop_file_info_get_show_in (self);
#line 73 "../src/synapse-core/desktop-file-service.vala"
	if (old_value != value) {
#line 73 "../src/synapse-core/desktop-file-service.vala"
		self->priv->_show_in = value;
#line 73 "../src/synapse-core/desktop-file-service.vala"
		g_object_notify_by_pspec ((GObject *) self, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY]);
#line 1423 "desktop-file-service.c"
	}
}

static void
synapse_desktop_file_info_class_init (SynapseDesktopFileInfoClass * klass,
                                      gpointer klass_data)
{
#line 28 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_info_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_type_class_adjust_private_offset (klass, &SynapseDesktopFileInfo_private_offset);
#line 28 "../src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_synapse_desktop_file_info_get_property;
#line 28 "../src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_synapse_desktop_file_info_set_property;
#line 28 "../src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->finalize = synapse_desktop_file_info_finalize;
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY] = g_param_spec_string ("desktop-id", "desktop-id", "desktop-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY] = g_param_spec_string ("generic-name", "generic-name", "generic-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY] = g_param_spec_string ("gettext-domain", "gettext-domain", "gettext-domain", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY] = g_param_spec_boolean ("needs-terminal", "needs-terminal", "needs-terminal", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY] = g_param_spec_string ("exec", "exec", "exec", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY] = g_param_spec_boolean ("is-hidden", "is-hidden", "is-hidden", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY] = g_param_spec_boolean ("is-valid", "is-valid", "is-valid", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/synapse-core/desktop-file-service.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY, synapse_desktop_file_info_properties[SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY] = g_param_spec_flags ("show-in", "show-in", "show-in", SYNAPSE_DESKTOP_FILE_INFO_TYPE_ENVIRONMENT_TYPE, SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1465 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_instance_init (SynapseDesktopFileInfo * self,
                                         gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 28 "../src/synapse-core/desktop-file-service.vala"
	self->priv = synapse_desktop_file_info_get_instance_private (self);
#line 52 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = g_strdup ("");
#line 52 "../src/synapse-core/desktop-file-service.vala"
	self->priv->_comment = _tmp0_;
#line 53 "../src/synapse-core/desktop-file-service.vala"
	_tmp1_ = g_strdup ("");
#line 53 "../src/synapse-core/desktop-file-service.vala"
	self->priv->_icon_name = _tmp1_;
#line 56 "../src/synapse-core/desktop-file-service.vala"
	self->priv->_needs_terminal = FALSE;
#line 61 "../src/synapse-core/desktop-file-service.vala"
	self->priv->_is_hidden = FALSE;
#line 62 "../src/synapse-core/desktop-file-service.vala"
	self->priv->_is_valid = TRUE;
#line 64 "../src/synapse-core/desktop-file-service.vala"
	self->priv->name_folded = NULL;
#line 73 "../src/synapse-core/desktop-file-service.vala"
	self->priv->_show_in = SYNAPSE_DESKTOP_FILE_INFO_ENVIRONMENT_TYPE_ALL;
#line 1494 "desktop-file-service.c"
}

static void
synapse_desktop_file_info_finalize (GObject * obj)
{
	SynapseDesktopFileInfo * self;
#line 28 "../src/synapse-core/desktop-file-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_DESKTOP_FILE_INFO, SynapseDesktopFileInfo);
#line 49 "../src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_desktop_id);
#line 50 "../src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_name);
#line 51 "../src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_generic_name);
#line 52 "../src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_comment);
#line 53 "../src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_icon_name);
#line 54 "../src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_gettext_domain);
#line 57 "../src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_filename);
#line 59 "../src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->_exec);
#line 64 "../src/synapse-core/desktop-file-service.vala"
	_g_free0 (self->priv->name_folded);
#line 28 "../src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (synapse_desktop_file_info_parent_class)->finalize (obj);
#line 1523 "desktop-file-service.c"
}

static GType
synapse_desktop_file_info_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseDesktopFileInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_desktop_file_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseDesktopFileInfo), 0, (GInstanceInitFunc) synapse_desktop_file_info_instance_init, NULL };
	GType synapse_desktop_file_info_type_id;
	synapse_desktop_file_info_type_id = g_type_register_static (G_TYPE_OBJECT, "SynapseDesktopFileInfo", &g_define_type_info, 0);
	SynapseDesktopFileInfo_private_offset = g_type_add_instance_private (synapse_desktop_file_info_type_id, sizeof (SynapseDesktopFileInfoPrivate));
	return synapse_desktop_file_info_type_id;
}

GType
synapse_desktop_file_info_get_type (void)
{
	static volatile gsize synapse_desktop_file_info_type_id__once = 0;
	if (g_once_init_enter (&synapse_desktop_file_info_type_id__once)) {
		GType synapse_desktop_file_info_type_id;
		synapse_desktop_file_info_type_id = synapse_desktop_file_info_get_type_once ();
		g_once_init_leave (&synapse_desktop_file_info_type_id__once, synapse_desktop_file_info_type_id);
	}
	return synapse_desktop_file_info_type_id__once;
}

static void
_vala_synapse_desktop_file_info_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SynapseDesktopFileInfo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_DESKTOP_FILE_INFO, SynapseDesktopFileInfo);
#line 28 "../src/synapse-core/desktop-file-service.vala"
	switch (property_id) {
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_desktop_id (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_name (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_generic_name (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_comment (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_icon_name (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_gettext_domain (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_boolean (value, synapse_desktop_file_info_get_needs_terminal (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_filename (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_string (value, synapse_desktop_file_info_get_exec (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_boolean (value, synapse_desktop_file_info_get_is_hidden (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_boolean (value, synapse_desktop_file_info_get_is_valid (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		g_value_set_flags (value, synapse_desktop_file_info_get_show_in (self));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 1630 "desktop-file-service.c"
		default:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 1636 "desktop-file-service.c"
	}
}

static void
_vala_synapse_desktop_file_info_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SynapseDesktopFileInfo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SYNAPSE_TYPE_DESKTOP_FILE_INFO, SynapseDesktopFileInfo);
#line 28 "../src/synapse-core/desktop-file-service.vala"
	switch (property_id) {
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_DESKTOP_ID_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_desktop_id (self, g_value_get_string (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_NAME_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_name (self, g_value_get_string (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_GENERIC_NAME_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_generic_name (self, g_value_get_string (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_COMMENT_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_comment (self, g_value_get_string (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_ICON_NAME_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_icon_name (self, g_value_get_string (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_GETTEXT_DOMAIN_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_gettext_domain (self, g_value_get_string (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_NEEDS_TERMINAL_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_needs_terminal (self, g_value_get_boolean (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_FILENAME_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_filename (self, g_value_get_string (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_EXEC_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_exec (self, g_value_get_string (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_HIDDEN_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_is_hidden (self, g_value_get_boolean (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_IS_VALID_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_is_valid (self, g_value_get_boolean (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 28 "../src/synapse-core/desktop-file-service.vala"
		case SYNAPSE_DESKTOP_FILE_INFO_SHOW_IN_PROPERTY:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		synapse_desktop_file_info_set_show_in (self, g_value_get_flags (value));
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 1722 "desktop-file-service.c"
		default:
#line 28 "../src/synapse-core/desktop-file-service.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/synapse-core/desktop-file-service.vala"
		break;
#line 1728 "desktop-file-service.c"
	}
}

static inline gpointer
synapse_desktop_file_service_get_instance_private (SynapseDesktopFileService* self)
{
	return G_STRUCT_MEMBER_P (self, SynapseDesktopFileService_private_offset);
}

SynapseDesktopFileService*
synapse_desktop_file_service_get_default (void)
{
	SynapseDesktopFileService* _tmp0_ = NULL;
	SynapseDesktopFileService* _tmp1_;
	SynapseDesktopFileService* _tmp2_;
	SynapseDesktopFileService* _tmp4_;
	SynapseDesktopFileService* result;
#line 196 "../src/synapse-core/desktop-file-service.vala"
	_tmp1_ = synapse_desktop_file_service_instance;
#line 196 "../src/synapse-core/desktop-file-service.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 196 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = _tmp2_;
#line 196 "../src/synapse-core/desktop-file-service.vala"
	if (_tmp0_ == NULL) {
#line 1754 "desktop-file-service.c"
		SynapseDesktopFileService* _tmp3_;
#line 196 "../src/synapse-core/desktop-file-service.vala"
		_tmp3_ = synapse_desktop_file_service_new ();
#line 196 "../src/synapse-core/desktop-file-service.vala"
		_g_object_unref0 (_tmp0_);
#line 196 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = _tmp3_;
#line 1762 "desktop-file-service.c"
	}
#line 196 "../src/synapse-core/desktop-file-service.vala"
	_tmp4_ = _tmp0_;
#line 196 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = NULL;
#line 196 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp4_;
#line 196 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (_tmp0_);
#line 196 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1774 "desktop-file-service.c"
}

static SynapseDesktopFileService*
synapse_desktop_file_service_construct (GType object_type)
{
	SynapseDesktopFileService * self = NULL;
#line 201 "../src/synapse-core/desktop-file-service.vala"
	self = (SynapseDesktopFileService*) g_object_new (object_type, NULL);
#line 201 "../src/synapse-core/desktop-file-service.vala"
	return self;
#line 1785 "desktop-file-service.c"
}

static SynapseDesktopFileService*
synapse_desktop_file_service_new (void)
{
#line 201 "../src/synapse-core/desktop-file-service.vala"
	return synapse_desktop_file_service_construct (SYNAPSE_TYPE_DESKTOP_FILE_SERVICE);
#line 1793 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_initialize_data_free (gpointer _data)
{
	SynapseDesktopFileServiceInitializeData* _data_;
	_data_ = _data;
#line 190 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (_data_->self);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	g_slice_free (SynapseDesktopFileServiceInitializeData, _data_);
#line 1805 "desktop-file-service.c"
}

void
synapse_desktop_file_service_initialize (SynapseDesktopFileService* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	SynapseDesktopFileServiceInitializeData* _data_;
	SynapseDesktopFileService* _tmp0_;
#line 190 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	_data_ = g_slice_new0 (SynapseDesktopFileServiceInitializeData);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	g_task_set_task_data (_data_->_async_result, _data_, synapse_desktop_file_service_initialize_data_free);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	_data_->self = _tmp0_;
#line 190 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_initialize_co (_data_);
#line 1829 "desktop-file-service.c"
}

void
synapse_desktop_file_service_initialize_finish (SynapseDesktopFileService* self,
                                                GAsyncResult* _res_)
{
	SynapseDesktopFileServiceInitializeData* _data_;
#line 190 "../src/synapse-core/desktop-file-service.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1839 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_initialize_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	SynapseDesktopFileServiceInitializeData* _data_;
#line 240 "../src/synapse-core/desktop-file-service.vala"
	_data_ = _user_data_;
#line 240 "../src/synapse-core/desktop-file-service.vala"
	_data_->_source_object_ = source_object;
#line 240 "../src/synapse-core/desktop-file-service.vala"
	_data_->_res_ = _res_;
#line 240 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_initialize_co (_data_);
#line 1856 "desktop-file-service.c"
}

static void
_synapse_desktop_file_service_queue_cache_update_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                             gpointer self)
{
#line 248 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_queue_cache_update ((SynapseDesktopFileService*) self);
#line 1865 "desktop-file-service.c"
}

static gboolean
synapse_desktop_file_service_initialize_co (SynapseDesktopFileServiceInitializeData* _data_)
{
#line 236 "../src/synapse-core/desktop-file-service.vala"
	switch (_data_->_state_) {
#line 236 "../src/synapse-core/desktop-file-service.vala"
		case 0:
#line 1875 "desktop-file-service.c"
		goto _state_0;
#line 236 "../src/synapse-core/desktop-file-service.vala"
		case 1:
#line 1879 "desktop-file-service.c"
		goto _state_1;
		default:
#line 236 "../src/synapse-core/desktop-file-service.vala"
		g_assert_not_reached ();
#line 1884 "desktop-file-service.c"
	}
	_state_0:
#line 237 "../src/synapse-core/desktop-file-service.vala"
	_data_->_tmp0_ = _data_->self->priv->init_once;
#line 237 "../src/synapse-core/desktop-file-service.vala"
	if (synapse_utils_async_once_is_initialized (_data_->_tmp0_)) {
#line 238 "../src/synapse-core/desktop-file-service.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 238 "../src/synapse-core/desktop-file-service.vala"
		if (_data_->_state_ != 0) {
#line 238 "../src/synapse-core/desktop-file-service.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 238 "../src/synapse-core/desktop-file-service.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1899 "desktop-file-service.c"
			}
		}
#line 238 "../src/synapse-core/desktop-file-service.vala"
		g_object_unref (_data_->_async_result);
#line 238 "../src/synapse-core/desktop-file-service.vala"
		return FALSE;
#line 1906 "desktop-file-service.c"
	}
#line 240 "../src/synapse-core/desktop-file-service.vala"
	_data_->_tmp1_ = _data_->self->priv->init_once;
#line 240 "../src/synapse-core/desktop-file-service.vala"
	_data_->_state_ = 1;
#line 240 "../src/synapse-core/desktop-file-service.vala"
	synapse_utils_async_once_enter (_data_->_tmp1_, synapse_desktop_file_service_initialize_ready, _data_);
#line 240 "../src/synapse-core/desktop-file-service.vala"
	return FALSE;
#line 1916 "desktop-file-service.c"
	_state_1:
#line 240 "../src/synapse-core/desktop-file-service.vala"
	_data_->is_locked = synapse_utils_async_once_enter_finish (_data_->_tmp1_, _data_->_res_);
#line 241 "../src/synapse-core/desktop-file-service.vala"
	if (!_data_->is_locked) {
#line 242 "../src/synapse-core/desktop-file-service.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 242 "../src/synapse-core/desktop-file-service.vala"
		if (_data_->_state_ != 0) {
#line 242 "../src/synapse-core/desktop-file-service.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 242 "../src/synapse-core/desktop-file-service.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1930 "desktop-file-service.c"
			}
		}
#line 242 "../src/synapse-core/desktop-file-service.vala"
		g_object_unref (_data_->_async_result);
#line 242 "../src/synapse-core/desktop-file-service.vala"
		return FALSE;
#line 1937 "desktop-file-service.c"
	}
#line 245 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_load_all_desktop_files (_data_->self);
#line 247 "../src/synapse-core/desktop-file-service.vala"
	_data_->_tmp2_ = g_app_info_monitor_get ();
#line 247 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (_data_->self->priv->app_info_monitor);
#line 247 "../src/synapse-core/desktop-file-service.vala"
	_data_->self->priv->app_info_monitor = _data_->_tmp2_;
#line 248 "../src/synapse-core/desktop-file-service.vala"
	_data_->_tmp3_ = _data_->self->priv->app_info_monitor;
#line 248 "../src/synapse-core/desktop-file-service.vala"
	g_signal_connect_object (_data_->_tmp3_, "changed", (GCallback) _synapse_desktop_file_service_queue_cache_update_g_app_info_monitor_changed, _data_->self, 0);
#line 250 "../src/synapse-core/desktop-file-service.vala"
	_data_->_tmp4_ = _data_->self->priv->init_once;
#line 250 "../src/synapse-core/desktop-file-service.vala"
	synapse_utils_async_once_leave (_data_->_tmp4_, (gpointer) ((gintptr) TRUE));
#line 236 "../src/synapse-core/desktop-file-service.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 236 "../src/synapse-core/desktop-file-service.vala"
	if (_data_->_state_ != 0) {
#line 236 "../src/synapse-core/desktop-file-service.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 236 "../src/synapse-core/desktop-file-service.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1963 "desktop-file-service.c"
		}
	}
#line 236 "../src/synapse-core/desktop-file-service.vala"
	g_object_unref (_data_->_async_result);
#line 236 "../src/synapse-core/desktop-file-service.vala"
	return FALSE;
#line 1970 "desktop-file-service.c"
}

static gboolean
__lambda6_ (SynapseDesktopFileService* self)
{
	gboolean result;
#line 261 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_load_all_desktop_files (self);
#line 262 "../src/synapse-core/desktop-file-service.vala"
	g_signal_emit (self, synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_DONE_SIGNAL], 0);
#line 264 "../src/synapse-core/desktop-file-service.vala"
	self->priv->queued_update_id = (guint) 0;
#line 266 "../src/synapse-core/desktop-file-service.vala"
	result = G_SOURCE_REMOVE;
#line 266 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1987 "desktop-file-service.c"
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ ((SynapseDesktopFileService*) self);
#line 260 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 1997 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_queue_cache_update (SynapseDesktopFileService* self)
{
#line 253 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/synapse-core/desktop-file-service.vala"
	g_signal_emit (self, synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_STARTED_SIGNAL], 0);
#line 256 "../src/synapse-core/desktop-file-service.vala"
	if (self->priv->queued_update_id != ((guint) 0)) {
#line 257 "../src/synapse-core/desktop-file-service.vala"
		g_source_remove (self->priv->queued_update_id);
#line 2011 "desktop-file-service.c"
	}
#line 260 "../src/synapse-core/desktop-file-service.vala"
	self->priv->queued_update_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) SYNAPSE_DESKTOP_FILE_SERVICE_DEFAULT_TIMEOUT_SECONDS, ___lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 2015 "desktop-file-service.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 288 "../src/synapse-core/desktop-file-service.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2023 "desktop-file-service.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 288 "../src/synapse-core/desktop-file-service.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2031 "desktop-file-service.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 2052 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_load_all_desktop_files (SynapseDesktopFileService* self)
{
	GeeList* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GList* app_infos = NULL;
	GList* _tmp3_;
	GList* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 271 "../src/synapse-core/desktop-file-service.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->non_hidden_desktop_files;
#line 272 "../src/synapse-core/desktop-file-service.vala"
	gee_collection_clear ((GeeCollection*) _tmp0_);
#line 273 "../src/synapse-core/desktop-file-service.vala"
	_tmp1_ = self->priv->exec_map;
#line 273 "../src/synapse-core/desktop-file-service.vala"
	gee_map_clear (_tmp1_);
#line 274 "../src/synapse-core/desktop-file-service.vala"
	_tmp2_ = self->priv->desktop_id_map;
#line 274 "../src/synapse-core/desktop-file-service.vala"
	gee_map_clear (_tmp2_);
#line 276 "../src/synapse-core/desktop-file-service.vala"
	_tmp3_ = g_app_info_get_all ();
#line 276 "../src/synapse-core/desktop-file-service.vala"
	app_infos = _tmp3_;
#line 277 "../src/synapse-core/desktop-file-service.vala"
	_tmp4_ = app_infos;
#line 2085 "desktop-file-service.c"
	{
		GList* app_collection = NULL;
		GList* app_it = NULL;
#line 277 "../src/synapse-core/desktop-file-service.vala"
		app_collection = _tmp4_;
#line 277 "../src/synapse-core/desktop-file-service.vala"
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
#line 2093 "desktop-file-service.c"
			GAppInfo* app = NULL;
#line 277 "../src/synapse-core/desktop-file-service.vala"
			app = (GAppInfo*) app_it->data;
#line 2097 "desktop-file-service.c"
			{
				GAppInfo* _tmp5_;
#line 278 "../src/synapse-core/desktop-file-service.vala"
				_tmp5_ = app;
#line 278 "../src/synapse-core/desktop-file-service.vala"
				if (g_app_info_should_show (_tmp5_)) {
#line 2104 "desktop-file-service.c"
					GDesktopAppInfo* app_info = NULL;
					GAppInfo* _tmp6_;
					SynapseDesktopFileInfo* dfi = NULL;
					GDesktopAppInfo* _tmp7_;
					SynapseDesktopFileInfo* _tmp8_;
					GeeList* _tmp9_;
					SynapseDesktopFileInfo* _tmp10_;
					GeeMap* _tmp11_;
					SynapseDesktopFileInfo* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					SynapseDesktopFileInfo* _tmp15_;
					gchar* exec = NULL;
					SynapseDesktopFileInfo* _tmp16_;
					const gchar* _tmp17_;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					GRegex* _tmp20_;
					GeeList* exec_list = NULL;
					GeeMap* _tmp32_;
					const gchar* _tmp33_;
					gpointer _tmp34_;
					GeeList* _tmp35_;
					GeeList* _tmp40_;
					SynapseDesktopFileInfo* _tmp41_;
#line 279 "../src/synapse-core/desktop-file-service.vala"
					_tmp6_ = app;
#line 279 "../src/synapse-core/desktop-file-service.vala"
					app_info = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, G_TYPE_DESKTOP_APP_INFO, GDesktopAppInfo);
#line 280 "../src/synapse-core/desktop-file-service.vala"
					_tmp7_ = app_info;
#line 280 "../src/synapse-core/desktop-file-service.vala"
					_tmp8_ = synapse_desktop_file_info_new_for_desktop_app_info (_tmp7_);
#line 280 "../src/synapse-core/desktop-file-service.vala"
					dfi = _tmp8_;
#line 282 "../src/synapse-core/desktop-file-service.vala"
					_tmp9_ = self->priv->non_hidden_desktop_files;
#line 282 "../src/synapse-core/desktop-file-service.vala"
					_tmp10_ = dfi;
#line 282 "../src/synapse-core/desktop-file-service.vala"
					gee_collection_add ((GeeCollection*) _tmp9_, _tmp10_);
#line 283 "../src/synapse-core/desktop-file-service.vala"
					_tmp11_ = self->priv->desktop_id_map;
#line 283 "../src/synapse-core/desktop-file-service.vala"
					_tmp12_ = dfi;
#line 283 "../src/synapse-core/desktop-file-service.vala"
					_tmp13_ = synapse_desktop_file_info_get_desktop_id (_tmp12_);
#line 283 "../src/synapse-core/desktop-file-service.vala"
					_tmp14_ = _tmp13_;
#line 283 "../src/synapse-core/desktop-file-service.vala"
					_tmp15_ = dfi;
#line 283 "../src/synapse-core/desktop-file-service.vala"
					gee_map_set (_tmp11_, _tmp14_, _tmp15_);
#line 285 "../src/synapse-core/desktop-file-service.vala"
					_tmp16_ = dfi;
#line 285 "../src/synapse-core/desktop-file-service.vala"
					_tmp17_ = synapse_desktop_file_info_get_exec (_tmp16_);
#line 285 "../src/synapse-core/desktop-file-service.vala"
					_tmp18_ = _tmp17_;
#line 285 "../src/synapse-core/desktop-file-service.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 285 "../src/synapse-core/desktop-file-service.vala"
					exec = _tmp19_;
#line 286 "../src/synapse-core/desktop-file-service.vala"
					_tmp20_ = self->priv->exec_regex;
#line 286 "../src/synapse-core/desktop-file-service.vala"
					if (_tmp20_ != NULL) {
#line 2172 "desktop-file-service.c"
						{
							gchar* _tmp21_ = NULL;
							GRegex* _tmp22_;
							SynapseDesktopFileInfo* _tmp23_;
							const gchar* _tmp24_;
							const gchar* _tmp25_;
							gchar* _tmp26_;
							gchar* _tmp27_;
							const gchar* _tmp28_;
							gchar* _tmp29_;
#line 288 "../src/synapse-core/desktop-file-service.vala"
							_tmp22_ = self->priv->exec_regex;
#line 288 "../src/synapse-core/desktop-file-service.vala"
							_tmp23_ = dfi;
#line 288 "../src/synapse-core/desktop-file-service.vala"
							_tmp24_ = synapse_desktop_file_info_get_exec (_tmp23_);
#line 288 "../src/synapse-core/desktop-file-service.vala"
							_tmp25_ = _tmp24_;
#line 288 "../src/synapse-core/desktop-file-service.vala"
							_tmp26_ = g_regex_replace_literal (_tmp22_, _tmp25_, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 288 "../src/synapse-core/desktop-file-service.vala"
							_tmp21_ = _tmp26_;
#line 288 "../src/synapse-core/desktop-file-service.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../src/synapse-core/desktop-file-service.vala"
								if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2199 "desktop-file-service.c"
									goto __catch0_g_regex_error;
								}
#line 288 "../src/synapse-core/desktop-file-service.vala"
								_g_free0 (exec);
#line 288 "../src/synapse-core/desktop-file-service.vala"
								_g_object_unref0 (dfi);
#line 288 "../src/synapse-core/desktop-file-service.vala"
								(app_infos == NULL) ? NULL : (app_infos = (_g_list_free__g_object_unref0_ (app_infos), NULL));
#line 288 "../src/synapse-core/desktop-file-service.vala"
								g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 288 "../src/synapse-core/desktop-file-service.vala"
								g_clear_error (&_inner_error0_);
#line 288 "../src/synapse-core/desktop-file-service.vala"
								return;
#line 2214 "desktop-file-service.c"
							}
#line 288 "../src/synapse-core/desktop-file-service.vala"
							_tmp27_ = _tmp21_;
#line 288 "../src/synapse-core/desktop-file-service.vala"
							_tmp21_ = NULL;
#line 288 "../src/synapse-core/desktop-file-service.vala"
							_g_free0 (exec);
#line 288 "../src/synapse-core/desktop-file-service.vala"
							exec = _tmp27_;
#line 289 "../src/synapse-core/desktop-file-service.vala"
							_tmp28_ = exec;
#line 289 "../src/synapse-core/desktop-file-service.vala"
							_tmp29_ = string_strip (_tmp28_);
#line 289 "../src/synapse-core/desktop-file-service.vala"
							_g_free0 (exec);
#line 289 "../src/synapse-core/desktop-file-service.vala"
							exec = _tmp29_;
#line 287 "../src/synapse-core/desktop-file-service.vala"
							_g_free0 (_tmp21_);
#line 2234 "desktop-file-service.c"
						}
						goto __finally0;
						__catch0_g_regex_error:
						{
							GError* err = NULL;
							GError* _tmp30_;
							const gchar* _tmp31_;
#line 287 "../src/synapse-core/desktop-file-service.vala"
							err = _inner_error0_;
#line 287 "../src/synapse-core/desktop-file-service.vala"
							_inner_error0_ = NULL;
#line 291 "../src/synapse-core/desktop-file-service.vala"
							_tmp30_ = err;
#line 291 "../src/synapse-core/desktop-file-service.vala"
							_tmp31_ = _tmp30_->message;
#line 291 "../src/synapse-core/desktop-file-service.vala"
							g_critical ("desktop-file-service.vala:291: %s", _tmp31_);
#line 287 "../src/synapse-core/desktop-file-service.vala"
							_g_error_free0 (err);
#line 2254 "desktop-file-service.c"
						}
						__finally0:
#line 287 "../src/synapse-core/desktop-file-service.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 287 "../src/synapse-core/desktop-file-service.vala"
							_g_free0 (exec);
#line 287 "../src/synapse-core/desktop-file-service.vala"
							_g_object_unref0 (dfi);
#line 287 "../src/synapse-core/desktop-file-service.vala"
							(app_infos == NULL) ? NULL : (app_infos = (_g_list_free__g_object_unref0_ (app_infos), NULL));
#line 287 "../src/synapse-core/desktop-file-service.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 287 "../src/synapse-core/desktop-file-service.vala"
							g_clear_error (&_inner_error0_);
#line 287 "../src/synapse-core/desktop-file-service.vala"
							return;
#line 2271 "desktop-file-service.c"
						}
					}
#line 296 "../src/synapse-core/desktop-file-service.vala"
					_tmp32_ = self->priv->exec_map;
#line 296 "../src/synapse-core/desktop-file-service.vala"
					_tmp33_ = exec;
#line 296 "../src/synapse-core/desktop-file-service.vala"
					_tmp34_ = gee_map_get (_tmp32_, _tmp33_);
#line 296 "../src/synapse-core/desktop-file-service.vala"
					exec_list = (GeeList*) _tmp34_;
#line 297 "../src/synapse-core/desktop-file-service.vala"
					_tmp35_ = exec_list;
#line 297 "../src/synapse-core/desktop-file-service.vala"
					if (_tmp35_ == NULL) {
#line 2286 "desktop-file-service.c"
						GeeArrayList* _tmp36_;
						GeeMap* _tmp37_;
						const gchar* _tmp38_;
						GeeList* _tmp39_;
#line 298 "../src/synapse-core/desktop-file-service.vala"
						_tmp36_ = gee_array_list_new (SYNAPSE_TYPE_DESKTOP_FILE_INFO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 298 "../src/synapse-core/desktop-file-service.vala"
						_g_object_unref0 (exec_list);
#line 298 "../src/synapse-core/desktop-file-service.vala"
						exec_list = (GeeList*) _tmp36_;
#line 299 "../src/synapse-core/desktop-file-service.vala"
						_tmp37_ = self->priv->exec_map;
#line 299 "../src/synapse-core/desktop-file-service.vala"
						_tmp38_ = exec;
#line 299 "../src/synapse-core/desktop-file-service.vala"
						_tmp39_ = exec_list;
#line 299 "../src/synapse-core/desktop-file-service.vala"
						gee_map_set (_tmp37_, _tmp38_, _tmp39_);
#line 2305 "desktop-file-service.c"
					}
#line 301 "../src/synapse-core/desktop-file-service.vala"
					_tmp40_ = exec_list;
#line 301 "../src/synapse-core/desktop-file-service.vala"
					_tmp41_ = dfi;
#line 301 "../src/synapse-core/desktop-file-service.vala"
					gee_collection_add ((GeeCollection*) _tmp40_, _tmp41_);
#line 278 "../src/synapse-core/desktop-file-service.vala"
					_g_object_unref0 (exec_list);
#line 278 "../src/synapse-core/desktop-file-service.vala"
					_g_free0 (exec);
#line 278 "../src/synapse-core/desktop-file-service.vala"
					_g_object_unref0 (dfi);
#line 2319 "desktop-file-service.c"
				}
			}
		}
	}
#line 271 "../src/synapse-core/desktop-file-service.vala"
	(app_infos == NULL) ? NULL : (app_infos = (_g_list_free__g_object_unref0_ (app_infos), NULL));
#line 2326 "desktop-file-service.c"
}

GeeList*
synapse_desktop_file_service_get_desktop_files (SynapseDesktopFileService* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	GeeList* result;
#line 307 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->non_hidden_desktop_files;
#line 308 "../src/synapse-core/desktop-file-service.vala"
	_tmp1_ = gee_list_get_read_only_view (_tmp0_);
#line 308 "../src/synapse-core/desktop-file-service.vala"
	_tmp2_ = _tmp1_;
#line 308 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp2_;
#line 308 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 2348 "desktop-file-service.c"
}

GeeList*
synapse_desktop_file_service_get_desktop_files_for_exec (SynapseDesktopFileService* self,
                                                         const gchar* exec)
{
	GeeList* _tmp0_ = NULL;
	GeeMap* _tmp1_;
	gpointer _tmp2_;
	GeeList* _tmp4_;
	GeeList* result;
#line 311 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 311 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (exec != NULL, NULL);
#line 312 "../src/synapse-core/desktop-file-service.vala"
	_tmp1_ = self->priv->exec_map;
#line 312 "../src/synapse-core/desktop-file-service.vala"
	_tmp2_ = gee_map_get (_tmp1_, exec);
#line 312 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = (GeeList*) _tmp2_;
#line 312 "../src/synapse-core/desktop-file-service.vala"
	if (_tmp0_ == NULL) {
#line 2372 "desktop-file-service.c"
		GeeArrayList* _tmp3_;
#line 312 "../src/synapse-core/desktop-file-service.vala"
		_tmp3_ = gee_array_list_new (SYNAPSE_TYPE_DESKTOP_FILE_INFO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 312 "../src/synapse-core/desktop-file-service.vala"
		_g_object_unref0 (_tmp0_);
#line 312 "../src/synapse-core/desktop-file-service.vala"
		_tmp0_ = (GeeList*) _tmp3_;
#line 2380 "desktop-file-service.c"
	}
#line 312 "../src/synapse-core/desktop-file-service.vala"
	_tmp4_ = _tmp0_;
#line 312 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = NULL;
#line 312 "../src/synapse-core/desktop-file-service.vala"
	result = _tmp4_;
#line 312 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (_tmp0_);
#line 312 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 2392 "desktop-file-service.c"
}

SynapseDesktopFileInfo*
synapse_desktop_file_service_get_desktop_file_for_id (SynapseDesktopFileService* self,
                                                      const gchar* desktop_id)
{
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	SynapseDesktopFileInfo* result;
#line 315 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 315 "../src/synapse-core/desktop-file-service.vala"
	g_return_val_if_fail (desktop_id != NULL, NULL);
#line 316 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = self->priv->desktop_id_map;
#line 316 "../src/synapse-core/desktop-file-service.vala"
	_tmp1_ = gee_map_get (_tmp0_, desktop_id);
#line 316 "../src/synapse-core/desktop-file-service.vala"
	result = (SynapseDesktopFileInfo*) _tmp1_;
#line 316 "../src/synapse-core/desktop-file-service.vala"
	return result;
#line 2414 "desktop-file-service.c"
}

static GObject *
synapse_desktop_file_service_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SynapseDesktopFileService * self;
	GeeArrayList* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	SynapseUtilsAsyncOnce* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 214 "../src/synapse-core/desktop-file-service.vala"
	parent_class = G_OBJECT_CLASS (synapse_desktop_file_service_parent_class);
#line 214 "../src/synapse-core/desktop-file-service.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 214 "../src/synapse-core/desktop-file-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_DESKTOP_FILE_SERVICE, SynapseDesktopFileService);
#line 215 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_instance = self;
#line 217 "../src/synapse-core/desktop-file-service.vala"
	_tmp0_ = gee_array_list_new (SYNAPSE_TYPE_DESKTOP_FILE_INFO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 217 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->non_hidden_desktop_files);
#line 217 "../src/synapse-core/desktop-file-service.vala"
	self->priv->non_hidden_desktop_files = (GeeList*) _tmp0_;
#line 218 "../src/synapse-core/desktop-file-service.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 218 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->exec_map);
#line 218 "../src/synapse-core/desktop-file-service.vala"
	self->priv->exec_map = (GeeMap*) _tmp1_;
#line 219 "../src/synapse-core/desktop-file-service.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SYNAPSE_TYPE_DESKTOP_FILE_INFO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 219 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->desktop_id_map);
#line 219 "../src/synapse-core/desktop-file-service.vala"
	self->priv->desktop_id_map = (GeeMap*) _tmp2_;
#line 221 "../src/synapse-core/desktop-file-service.vala"
	_tmp3_ = synapse_utils_async_once_new (G_TYPE_BOOLEAN, NULL, NULL);
#line 221 "../src/synapse-core/desktop-file-service.vala"
	_synapse_utils_async_once_unref0 (self->priv->init_once);
#line 221 "../src/synapse-core/desktop-file-service.vala"
	self->priv->init_once = _tmp3_;
#line 2462 "desktop-file-service.c"
	{
		GRegex* _tmp4_ = NULL;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
#line 224 "../src/synapse-core/desktop-file-service.vala"
		_tmp5_ = g_regex_new ("%[fFuU]", 0, 0, &_inner_error0_);
#line 224 "../src/synapse-core/desktop-file-service.vala"
		_tmp4_ = _tmp5_;
#line 224 "../src/synapse-core/desktop-file-service.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2473 "desktop-file-service.c"
			goto __catch0_g_error;
		}
#line 224 "../src/synapse-core/desktop-file-service.vala"
		_tmp6_ = _tmp4_;
#line 224 "../src/synapse-core/desktop-file-service.vala"
		_tmp4_ = NULL;
#line 224 "../src/synapse-core/desktop-file-service.vala"
		_g_regex_unref0 (self->priv->exec_regex);
#line 224 "../src/synapse-core/desktop-file-service.vala"
		self->priv->exec_regex = _tmp6_;
#line 223 "../src/synapse-core/desktop-file-service.vala"
		_g_regex_unref0 (_tmp4_);
#line 2486 "desktop-file-service.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 223 "../src/synapse-core/desktop-file-service.vala"
		err = _inner_error0_;
#line 223 "../src/synapse-core/desktop-file-service.vala"
		_inner_error0_ = NULL;
#line 226 "../src/synapse-core/desktop-file-service.vala"
		_tmp7_ = err;
#line 226 "../src/synapse-core/desktop-file-service.vala"
		_tmp8_ = _tmp7_->message;
#line 226 "../src/synapse-core/desktop-file-service.vala"
		g_warning ("desktop-file-service.vala:226: Unable to construct exec regex: %s", _tmp8_);
#line 223 "../src/synapse-core/desktop-file-service.vala"
		_g_error_free0 (err);
#line 2506 "desktop-file-service.c"
	}
	__finally0:
#line 223 "../src/synapse-core/desktop-file-service.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "../src/synapse-core/desktop-file-service.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 223 "../src/synapse-core/desktop-file-service.vala"
		g_clear_error (&_inner_error0_);
#line 2515 "desktop-file-service.c"
	}
#line 229 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_initialize (self, NULL, NULL);
#line 214 "../src/synapse-core/desktop-file-service.vala"
	return obj;
#line 2521 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_class_init (SynapseDesktopFileServiceClass * klass,
                                         gpointer klass_data)
{
#line 190 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_parent_class = g_type_class_peek_parent (klass);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	g_type_class_adjust_private_offset (klass, &SynapseDesktopFileService_private_offset);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->constructor = synapse_desktop_file_service_constructor;
#line 190 "../src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (klass)->finalize = synapse_desktop_file_service_finalize;
#line 190 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_STARTED_SIGNAL] = g_signal_new ("reload-started", SYNAPSE_TYPE_DESKTOP_FILE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_signals[SYNAPSE_DESKTOP_FILE_SERVICE_RELOAD_DONE_SIGNAL] = g_signal_new ("reload-done", SYNAPSE_TYPE_DESKTOP_FILE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2540 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_instance_init (SynapseDesktopFileService * self,
                                            gpointer klass)
{
#line 190 "../src/synapse-core/desktop-file-service.vala"
	self->priv = synapse_desktop_file_service_get_instance_private (self);
#line 211 "../src/synapse-core/desktop-file-service.vala"
	self->priv->queued_update_id = (guint) 0;
#line 2551 "desktop-file-service.c"
}

static void
synapse_desktop_file_service_finalize (GObject * obj)
{
	SynapseDesktopFileService * self;
#line 190 "../src/synapse-core/desktop-file-service.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SYNAPSE_TYPE_DESKTOP_FILE_SERVICE, SynapseDesktopFileService);
#line 233 "../src/synapse-core/desktop-file-service.vala"
	synapse_desktop_file_service_instance = NULL;
#line 192 "../src/synapse-core/desktop-file-service.vala"
	_synapse_utils_async_once_unref0 (self->priv->init_once);
#line 203 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->app_info_monitor);
#line 204 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->non_hidden_desktop_files);
#line 205 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->exec_map);
#line 206 "../src/synapse-core/desktop-file-service.vala"
	_g_object_unref0 (self->priv->desktop_id_map);
#line 212 "../src/synapse-core/desktop-file-service.vala"
	_g_regex_unref0 (self->priv->exec_regex);
#line 190 "../src/synapse-core/desktop-file-service.vala"
	G_OBJECT_CLASS (synapse_desktop_file_service_parent_class)->finalize (obj);
#line 2576 "desktop-file-service.c"
}

static GType
synapse_desktop_file_service_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseDesktopFileServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_desktop_file_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseDesktopFileService), 0, (GInstanceInitFunc) synapse_desktop_file_service_instance_init, NULL };
	GType synapse_desktop_file_service_type_id;
	synapse_desktop_file_service_type_id = g_type_register_static (G_TYPE_OBJECT, "SynapseDesktopFileService", &g_define_type_info, 0);
	SynapseDesktopFileService_private_offset = g_type_add_instance_private (synapse_desktop_file_service_type_id, sizeof (SynapseDesktopFileServicePrivate));
	return synapse_desktop_file_service_type_id;
}

GType
synapse_desktop_file_service_get_type (void)
{
	static volatile gsize synapse_desktop_file_service_type_id__once = 0;
	if (g_once_init_enter (&synapse_desktop_file_service_type_id__once)) {
		GType synapse_desktop_file_service_type_id;
		synapse_desktop_file_service_type_id = synapse_desktop_file_service_get_type_once ();
		g_once_init_leave (&synapse_desktop_file_service_type_id__once, synapse_desktop_file_service_type_id);
	}
	return synapse_desktop_file_service_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 298 "../src/synapse-core/data-sink.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2608 "desktop-file-service.c"
		gssize i;
#line 298 "../src/synapse-core/data-sink.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 298 "../src/synapse-core/data-sink.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 298 "../src/synapse-core/data-sink.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2616 "desktop-file-service.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 298 "../src/synapse-core/data-sink.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 298 "../src/synapse-core/data-sink.vala"
	g_free (array);
#line 2631 "desktop-file-service.c"
}

